C *                    U.S.G.S. PROGRAM NO. E431                       *
C *               STEP-BACKWATER AND FLOODWAY ANALYSIS                 *
C *                         BY J.O. SHEARMAN                           *
C *                                                                    *
C ***REFERENCE***
C Shearman,J.O., 1976, Computer Applications for Step-Backwater
C and Floodway Analyses--Computer Program E431 User's Manual:
C U.S. Geological Survey Open File Report 76-499, 103 p. 
C
C ***NOTICE***
C THIS PROGRAM IS OBSOLETE AND ITS USE IS NOT RECOMMENDED AT THIS TIME.
C
C THIS PROGRAM IS MADE AVAILABLE SOLELY FOR HISTORICAL DOCUMENTATION
C OF HYDRAULIC COMPUTATIONS PREVIOUSLY PERFORMED WITH THIS PROGRAM.   
C
C THIS PROGRAM HAS BEEN SUPERSEDED BY THE "WSPRO" WATER-SURFACE PROFILE
C COMPUTATION PROGRAM, DESIGNATED AS HYDRAULIC COMPUTER PROGRAM HY-7
C AND DESCRIBED IN U.S. DEPARTMENT OF TRANSPORTATION FEDERAL HIGHWAY
C ADMINISTRATION PUBLICATIONS:  FHWA-IP-89-027 (SEPTEMBER 1990) AND
C FHWA/RD-86/108 (JULY 1986), BY J.O. SHEARMAN.
C         
C THIS PROGRAM IS NOT SUPPORTED BY THE U.S.G.S.  NO ASSISTANCE CAN BE
C PROVIDED IN INSTALLING OR USING THE PROGRAM, IN INTERPRETING THE
C RESULTS OF COMPUTATIONS MADE WITH IT, OR IN RESOLVING ERRORS.
C
C ALTHOUGH THIS PROGRAM HAS BEEN USED BY THE U.S. GEOLOGICAL SURVEY,
C NO WARRANTY, EXPRESSED OR IMPLIED, IS MADE BY THE USGS AS TO THE
C ACCURACY AND FUNCTIONING OF THE PROGRAM AND RELATED PROGRAM MATERIAL,
C NOR SHALL THE FACT OF DISTRIBUTION CONSTITUTE ANY SUCH WARRANTY, AND
C NO RESPONSIBILITY IS ASSUMED BY THE USGS IN CONNECTION THEREWITH.
C   
C  PROGRAM MODIFICATION HISTORY
C ===================================================================
C
C   REVISED FOR   P R I M E   FORTRAN 77  ---- WK 6/83
C
C      COMPILE WITH  -SAVE  OPTION IN PRIME F77
C
C changes to original code are marked as in the following (designates
C old--original code and the end of the change)
C               C-old REAL*8 SECID
C                     CHARACTER*8 SECID
C               C---end change
C changes made to make it compatible with standard F77 for use on PC's
C and UNIX computers, rsregan Nov. 20, 1995
C
C ===================================================================
C
C-old REAL*8 SECID
      CHARACTER*8 SECID
C---end change
      INTEGER DATA
      LOGICAL FLDWAY,NO789,CD1SAV,ENDATA,FLUSH,USEMEM,RUNIT,JOB1
      COMMON /FLD/ METHOD(99),I3SEQ(99),Y(99),STAR(99),STAL(99),ELEV(99)
C-old COMMON /ID/ STRID(10),GSID(2),FWID(5),LINE
      CHARACTER*4 STRID, GSID, FWID
      COMMON /ID/ STRID(10),GSID(2),FWID(5)
      COMMON /IDI/ LINE
C---end change
      COMMON /AV/ IR11,IR12,IR13
      COMMON /NRAYS/ NSEQ3(99),NDATA(99),NFILE(99),NREC(99)
      COMMON /LOGPTR/ CD1SAV,ENDATA,NO789,FLUSH,RUNIT,JOB1
      COMMON /FW/ FLDWAY
      COMMON /PARM/ INX,INQ,ITOL,IDELH,IFN,NOQ,NXS
      COMMON /SAV/ SAVEL(99),USEMEM
      COMMON /FLAG/ DATA
      DIMENSION Q(20), IRUN(20), IELV(20)
C
C-new
      CHARACTER*72 FNAME, FNAME2, TMPFIL
      LOGICAL EXISTS
C---end change
C-old OPEN (UNIT=99, STATUS='SCRATCH')
      OPEN (UNIT=99, FILE='scr99', STATUS='SCRATCH')
C
C-old OPEN (UNIT=11, STATUS='SCRATCH', ACCESS='DIRECT', RECL=1424)
C-old OPEN (UNIT=12, STATUS='SCRATCH', ACCESS='DIRECT', RECL=1422)
C-old OPEN (UNIT=13, STATUS='SCRATCH', ACCESS='DIRECT', RECL=50)
C-new RECL measured in halfwords on Prime, bytes on pc's & Unix non-vms mode
      FNAME = 'e431.dat'
      LENNAM=8
      WRITE(*,7)
      WRITE(*,8)
   3  WRITE(*,5) 'input data', FNAME(1:LENNAM)
   5  FORMAT(//,' Enter the name of the ',A,' file',/,' (default= ',A,
     &       '): '$)
   6  FORMAT(//,' **ERROR** Specified file does not exist as specified',
     &       //)
      READ(*,'(A)') TMPFIL
      IF (TMPFIL.NE.' ') FNAME = TMPFIL
      CALL FILE_BASE(FNAME,LENNAM,LENBAS)
      INQUIRE (FILE=FNAME(1:LENNAM),EXIST=EXISTS)
      IF (.NOT.EXISTS) THEN
        WRITE(*,6)
        GOTO 3
      ENDIF
      FNAME2 = FNAME(1:LENBAS)//'.out '
      WRITE(*,5) 'printed results',FNAME2(1:LENBAS+4)
      READ(*,'(A)') TMPFIL
      IF (TMPFIL.NE.' ') FNAME2 = TMPFIL
      OPEN(5,FILE=FNAME,STATUS='OLD')
      OPEN(6,FILE=FNAME2,STATUS='UNKNOWN')
      OPEN (UNIT=11, FILE='scr11', STATUS='SCRATCH', ACCESS='DIRECT',
     &      RECL=2848)
      OPEN (UNIT=12, FILE='scr12', STATUS='SCRATCH', ACCESS='DIRECT',
     &      RECL=2844)
      OPEN (UNIT=13, FILE='scr13', STATUS='SCRATCH', ACCESS='DIRECT',
     &      RECL=100)
      FNAME =
     & '$Id: e431.f,v 1.8 1995/11/22 20:27:03 rsregan Exp rsregan $'
C     strings for Unix what command
      FNAME = '@(#)E431 - Step-backwater and floodway analysis model'
      FNAME = '@(#)E431 - USGS Open-File Report 76-499, J.O. Shearman'
      FNAME = '@(#)E431 - Contact: h2osoft@usgs.gov'
      FNAME = '@(#)E431 - Version: 83.180 1.8 1995/11/22'
    7 FORMAT(//,20X,'U.S.G.S. PROGRAM NO. E431',/,15X,
     &'STEP-BACKWATER AND FLOODWAY ANALYSIS',/,25X,
     &'BY J.O. SHEARMAN',//,' ***REFERENCE***',/,
     &' Shearman,J.O., 1976, Computer Applications for Step-Backwater'/
     &' and Floodway Analyses--Computer Program E431 User''s Manual:'/
     &' U.S. Geological Survey Open File Report 76-499, 103 p.'//,
     &' ***NOTICE***',/,' THIS PROGRAM IS OBSOLETE AND ITS USE IS NOT RE
     &COMMENDED AT THIS TIME.',//,
     &' THIS PROGRAM IS MADE AVAILABLE SOLELY FOR HISTORICAL DOCUMENTATI
     &ON'/' OF HYDRAULIC COMPUTATIONS PREVIOUSLY PERFORMED WITH THIS PRO
     &GRAM.',//,
     &' THIS PROGRAM HAS BEEN SUPERSEDED BY THE "WSPRO" WATER-SURFACE PR
     &OFILE'/' COMPUTATION PROGRAM, DESIGNATED AS HYDRAULIC COMPUTER PRO
     &GRAM HY-7'/' AND DESCRIBED IN U.S. DEPARTMENT OF TRANSPORTATION FE
     &DERAL HIGHWAY'/' ADMINISTRATION PUBLICATIONS FHWA-IP-89-027 (SEPTE
     &MBER 1990) AND',/,' FHWA/RD-86/108 (JULY 1986), BY J.O. SHEARMAN.'
     &)
   8  FORMAT(/' THIS PROGRAM IS NOT SUPPORTED BY THE U.S.G.S. NO ASSISTA
     &NCE CAN BE'/' PROVIDED IN INSTALLING OR USING THE PROGRAM, IN INTE
     &RPRETING THE'/' RESULTS OF COMPUTATIONS MADE WITH IT, OR IN RESOLV
     &ING ERRORS.',//,
     &' ALTHOUGH THIS PROGRAM HAS BEEN USED BY THE U.S. GEOLOGICAL SURVE
     &Y,'/' NO WARRANTY, EXPRESSED OR IMPLIED, IS MADE BY THE USGS AS TO
     & THE'/' ACCURACY AND FUNCTIONING OF THE PROGRAM AND RELATED PROGRA
     &M MATERIAL,'/' NOR SHALL THE FACT OF DISTRIBUTION CONSTITUTE ANY S
     &UCH WARRANTY, AND'/' NO RESPONSIBILITY IS ASSUMED BY THE USGS IN C
     &ONNECTION THEREWITH.'//)
C---end change
C
C  INITIALIZE FILE 13  --  150 RECORDS
      DO 13 IR13=1,150
C-old 13 WRITE(13'IR13) 0
   13 WRITE(13,REC=IR13) 0
C---end change
C
      CALL DOALOT (83.180)
C-new
      CALL VHEAD
      WRITE(6,7)
      WRITE(6,8)
C---end change
      CD1SAV=.FALSE.
      FLUSH=.FALSE.
      ENDATA=.FALSE.
      JOB1=.TRUE.
   10 CONTINUE
      CALL DATAIN (NXSKEP,NXSPRO,NXSFND)
      IF (ENDATA.AND.NXSFND.LE.0) GO TO 190
      NXSHYD=0
      IF (NXSKEP.LE.0) GO TO 20
      FLDWAY=.FALSE.
      USEMEM=.TRUE.
      CALL DATAED (NXSHYD,NXSKEP,NXSPRO,FLUSH)
      IF (.NOT.RUNIT) GO TO 180
   20 CONTINUE
      CALL VHEAD
      WRITE (6,200) STRID,GSID,NXS,NXSFND,NXSKEP,NXSHYD,NXSPRO
      IF (NXSHYD.LE.0) GO TO 180
      LINE=0
      DO 40 J=1,NXSHYD
      IF (NDATA(J).EQ.4.OR.NDATA(J).EQ.3) GO TO 40
      DATA=NDATA(J)
      CALL DREAD (NDATA(J),11,J,SECID,Q,*30,*30,*30,*30,*30)
   30 CONTINUE
      CALL PTABLE (IDELH,SECID)
   40 CONTINUE
      IF (NXSPRO.LE.0.OR.NOQ.LE.0) GO TO 180
      DELH=FLOAT(IDELH)/10.0
      IF (DELH.GT.0.5) DELH=0.5
      TOL=FLOAT(ITOL)/100.0
      FN=FLOAT(IFN)/10.0
      DO 50 I=1,NOQ
   50 IRUN(I)=0
      IF (NO789) GO TO 60
      CALL IN78 (IRUN,IELV)
   60 DO 170 IQ=1,NOQ
      IF (IRUN(IQ).EQ.0) GO TO 120
      FLDWAY=.TRUE.
      IF (FLUSH) GO TO 140
      CALL IN9
      IF (FLUSH) GO TO 140
      IF (IELV(IQ).EQ.1) USEMEM=.FALSE.
      LINE=0
      IREC=0
      I9=0
      DO 110 I=1,NXSPRO
      IF (NDATA(I).GT.1.AND.NDATA(I).NE.5) GO TO 110
      IF (I9.EQ.0) GO TO 70
      IF (NSEQ3(I).LT.I3SEQ(I9+1)) GO TO 80
   70 I9=I9+1
      IGO=METHOD(I9)
   80 IF (IGO.GT.4) GO TO 110
      CALL DREAD (NDATA(I),11,NREC(I),SECID,Q,*90,*90,*90,*90,*90)
   90 IF (IGO.EQ.4) GO TO 100
      XI=ELEV(I9)
      IF (USEMEM) XI=SAVEL(I)
  100 CALL CHOPK (IGO,SECID,XI,Y(I9),STAL(I9),STAR(I9))
      CALL PTABLE (IDELH,SECID)
      NFILE(I)=12
      IREC=IREC+1
      CALL DWRITE (NDATA(I),12,IREC,SECID,Q,*110)
  110 CONTINUE
      GO TO 140
  120 DO 130 I=1,NXSPRO
  130 SAVEL(I)=11000.
  140 CALL PROCAL (IQ,NXSPRO,FLUSH,Y(1),DELH,TOL,FN)
      NJREC=IR13-1
      IF (NJREC.EQ.0) GO TO 150
      IR13=1
      CALL OUTPUT (NJREC)
  150 IF (.NOT.FLDWAY) GO TO 170
      FLDWAY=.FALSE.
      USEMEM=.TRUE.
      IF (FLUSH) GO TO 170
      DO 160 I=1,NXSPRO
      IF (NFILE(I).NE.11) NFILE(I)=11
  160 CONTINUE
  170 CONTINUE
  180 IF (ENDATA) GO TO 190
      IF (JOB1) JOB1=.FALSE.
      GO TO 10
  190 STOP
  200 FORMAT ('0',19X,'INPUT SUMMARY FOR: ',10A4,1X,2A4//36X,I2,' CROSS
     1SECTIONS SPECIFIED (OR ASSUMED)'//30X,'FOUND',I3,' TYPE 3 CARDS'//
     230X,'KEPT',I4,' CROSS SECTIONS FOR EDITING'//36X,I2,3X,'"',6X,'"',
     35X,'VALID FOR PROPERTY COMPUTATIONS'//36X,I2,3X,'"',6X,'"',7X,'"',
     44X,'"  PROFILE',7X,'"')
      END
      BLOCK DATA
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
      COMMON /WCOEF/ HLHTH(36),COEF(36),LIMIT(3,2,2)
      COMMON /ARAYK/ ALLKB(11,4),ALLDK(6,8),ALLSG(7,8),ALLKE(5,5),ALLKS(
     18,6)
      COMMON /MCURV/ MKB(11),MJ(6),MSIG(7),MKE(5),MKS(8)
      COMMON /SUBM/ YUOVRZ(12),CDARAY(12),BEDEL,Z,ANET
      DATA MKB/0.0,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0/,ALLKB/2.14,1
     1.90,1.66,1.42,1.18,0.94,0.70,0.46,0.25,0.10,0.00,2.24,2.00,1.76,1.
     252,1.28,1.04,0.80,0.56,0.33,0.13,0.00,2.40,2.15,1.90,1.65,1.40,1.1
     35,0.90,0.65,0.40,0.17,0.00,3.58,3.11,2.46,1.95,1.50,1.12,0.79,0.50
     4,0.25,0.07,0.00/
      DATA YUOVRZ/0.9,1.0,1.05,1.1,1.15,1.2,1.25,1.3,1.4,1.5,1.7,2.0/,
     1CDARAY/0.10,0.10,0.27,0.37,0.425,0.445,0.463,0.475,0.49,0.495,0.50
     2,0.50/,BEDEL/0.0/,Z/0.0/,ANET/0.0/
      DATA MJ/0.0,0.02,0.04,0.06,0.08,0.18/,ALLDK/0.0,0.02,0.04,0.07,0.1
     10,0.28,0.0,0.03,0.07,0.11,0.15,0.39,0.0,0.04,0.08,0.13,0.18,0.43,0
     2.0,0.04,0.10,0.16,0.22,0.52,0.0,0.05,0.12,0.19,0.26,0.64,0.0,0.06,
     30.14,0.23,0.32,0.78,0.0,0.09,0.21,0.34,0.47,1.11,0.0,0.11,0.26,0.4
     42,0.58,1.38/
      DATA MSIG/0.4,0.5,0.6,0.7,0.8,0.9,1.0/,ALLSG/0.70,0.78,0.86,0.92,0
     1.96,0.99,1.00,0.66,0.75,0.84,0.90,0.95,0.98,1.00,0.645,0.735,0.825
     2,0.89,0.945,0.98,1.00,0.63,0.72,0.81,0.88,0.94,0.98,1.00,0.61,0.70
     35,0.80,0.875,0.935,0.975,1.00,0.59,0.69,0.79,0.87,0.93,0.97,1.00,0
     4.55,0.66,0.76,0.85,0.92,0.97,1.00,0.54,0.64,0.74,0.83,0.91,0.97,1.
     500/
      DATA MKE/0.2,0.55,0.7,0.85,1.00/,ALLKE/0.0,0.0,0.0,0.0,0.0,0.02,0.
     102,0.017,0.011,0.0,0.052,0.049,0.043,0.027,0.0,0.100,0.095,0.084,0
     2.056,0.0,0.173,0.163,0.144,0.097,0.0/
      DATA MKS/0.3,0.4,0.5,0.55,0.65,0.75,0.85,1.00/,ALLKS/-0.09,-0.05,-
     10.015,0.01,0.03,0.03,0.02,0.0,-0.27,-0.14,-0.04,0.01,0.065,0.08,0.
     206,0.0,-0.5,-0.27,-0.065,0.02,0.125,0.16,0.11,0.0,-0.15,-0.095,-0.
     306,-0.05,-0.03,-0.02,-0.01,0.0,-0.34,-0.25,-0.18,-0.15,-0.10,-0.06
     4,-0.025,0.0,-0.60,-0.43,-0.31,-0.26,-0.17,-0.11,-0.06,0.0/
      DATA HLHTH/0.15,0.215,0.28,0.15,0.27,0.31,0.0,0.15,0.25,0.50,0.90,
     14.0,0.0,0.5,1.0,1.5,2.0,2.5,3.0,4.0,0.80,0.84,0.88,0.90,0.92,0.94,
     20.96,1.00,0.70,0.80,0.86,0.90,0.92,0.94,0.96,1.00/,COEF/3.05,3.08,
     33.09,2.95,3.07,3.09,2.85,2.95,2.98,3.02,3.035,3.05,2.50,2.68,2.83,
     42.92,2.98,3.02,3.04,3.05,1.00,.988,.956,.929,.89,.82,.72,.36,1.00,
     5.988,.94,.88,.82,.73,.62,.2/,LIMIT/1,7,21,2,11,27,4,13,29,5,19,35/
      END
      SUBROUTINE ALPHIN (*,*,*)
C-old LOGICAL NOTBL,REPEAT
C-old INTEGER NOALPH(9)/'1','2','3','4','5','6','7','8','9'/,BALL(3)/2,2
C-old1,8/,BLANK/' '/
C-old COMMON /INALF/ ICARD,INPUTA(80),IBAD(80),JCARD,LCARD,NOTBL,LINES
      LOGICAL REPEAT
      CHARACTER*1 NOALPH(9), BLANK
      INTEGER BALL(3)
      CHARACTER*1 INPUTA, IBAD
      COMMON /INALFC/ INPUTA(80), IBAD(80)
      INTEGER ICARD, JCARD, LCARD, LINES
      LOGICAL NOTBL
      COMMON /INALF/ ICARD, JCARD, LCARD, LINES, NOTBL
      DATA NOALPH/'1','2','3','4','5','6','7','8','9'/, BALL/2,2,8/,
     1     BLANK/' '/
C---end change
C
C
      LCARD=JCARD
      JCARD=0
      IF (LCARD.LE.0) GO TO 10
      IF (.NOT.NOTBL) GO TO 30
   10 DO 20 I=1,80
   20 IBAD(I)=BLANK
      NOTBL=.FALSE.
   30 READ (5,140,END=90) INPUTA
      REWIND 99
C-old WRITE(99,140) INPUTA                     /******** WK 83.180
      WRITE(99,140) INPUTA
C---end change
      ENDFILE  99
      REWIND  99
      LINES=LINES+1
      DO 40 I=1,9
      IF (INPUTA(1).EQ.NOALPH(I)) JCARD=I
      IF (JCARD.GT.0) GO TO 50
   40 CONTINUE
      JCARD=-99
   50 IF (JCARD.EQ.7.OR.(JCARD.GT.0.AND.JCARD.LT.3)) GO TO 70
      IF (LINES.LT.45) GO TO 60
      CALL VHEAD
      LINES=0
      WRITE (6,120) (NOALPH(I),I=1,8)
   60 WRITE (6,130) INPUTA
   70 CALL EDITBJ (BALL,77,*80)
      IF (JCARD.EQ.ICARD) RETURN
      IF (LCARD.NE.ICARD) RETURN 3
      IF (JCARD.EQ.LCARD+1) RETURN 1
   80 RETURN 3
   90 RETURN 2
      ENTRY INITAL
      LINES=0
      CALL VHEAD
      WRITE (6,120) (NOALPH(I),I=1,8)
      RETURN
      ENTRY RPTMSG(REPEAT)
      WRITE (6,130) INPUTA
      IF (.NOT.REPEAT) GO TO 100
      WRITE (6,110)
      REPEAT=.FALSE.
  100 RETURN
  110 FORMAT ('+',82X,'**REPEAT PRINT**')
  120 FORMAT ( /27X,'*** INPUT CARD PRINTOUT ***'/'0',8(9X,A1)/' ',8('..
     1..5....0')/)
  130 FORMAT (' ',80A1)
  140 FORMAT (80A1)
      END
      SUBROUTINE BRIDGE
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
      LOGICAL NOROAD,NOKP,NOKS,FLOW1,FLOW2,FLOW3,MAYBE2
      INTEGER SKEW,PIER,ABUT,WW
      DIMENSION AJLIM(8), SAVE(7)
      COMMON /PROF/ WSD,WSU,VHD,VHU,KD,KU,HF,HE,AU,ALFU,DIST,QBO,A2N,H1N
     1,TOL,QT,QAVG,TEDS
      COMMON /QR/ QRL,QRR
      COMMON /BP1/ SKEW,PIER,ABUT,WW,SUBEL,BELMX
      COMMON /BP2/ M,IECC,E,AJ,IFLOW,BRWID,A2FULL,AJF
      COMMON /BP3/ IECCB4
      COMMON /BP4/ RGLMN,RGRMN,QTOL,RDIST
      COMMON /BP5/ KSTAR
      COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,DUM380
      COMMON /SUBM/ YUOVRZ(12),CDARAY(12),BEDEL,Z,ANET
Cunused COMMON /INTS/ SINTL,SINTR
      COMMON /PIERA/ ELPR(25),APR(25),NPA
      COMMON /LOGIG/ NOROAD,NOKP,NOKS
      DATA AJLIM/0.058,0.069,0.098,0.116,0.139,0.167,0.18,0.18/
      SAVE(1)=-9999.9
      HMIN=99999.9
      IECCB4=0
      QRR=0.0
      QRL=0.0
      IF (QTOL.LT.0.01) QTOL=0.01
      IFLOW=1
      FLOW1=.TRUE.
      FLOW2=.FALSE.
      FLOW3=.FALSE.
      MAYBE2=.TRUE.
      AJF=-0.001
      AJ=-0.001
      APIER=0.0
      IF (NOKP) GO TO 2
      APIER=TERPL8(WSD,1,NPA-1,ELPR,APR)
      AJ=APIER/A2N
      IF (AJ.GE.0.0) GO TO 1
      AJ=0.0
      APIER=0.0
    1 IF (AJ.LE.AJLIM(PIER)) GO TO 2
      AJ=AJLIM(PIER)
      CALL PRMSGZ (39,42,28,30)
C     PN-12* J EXCEEDS RANGE      ** USED J LIMIT
    2 IF (SUBEL.NE.0.0) GO TO 3
      MAYBE2=.FALSE.
      GO TO 5
C
    3 ANET=A2FULL
      IF (NOKP) GO TO 4
      ANET=ANET-APR(NPA)
      AJF=APR(NPA)/A2FULL
      A2FULL=ANET
    4 Z=ANET/BRWID
      BEDEL=SUBEL-Z
      IF (WSD.LT.BELMX) GO TO 5
      FLOW3=.TRUE.
      IFLOW=3
      FLOW1=.FALSE.
      GO TO 6
C
    5 CALL DETME
      CALL SETK
    6 IF (NOROAD) GO TO 7
      RMIN=AMIN1(RGLMN,RGRMN)
      HMIN=RMIN
      IF (HMIN.LT.H1N) HMIN=H1N
      IF (WSU.LE.RMIN) GO TO 7
      CALL ROADQ
      IF (QRL+QRR.LE.0.0) GO TO 7
      QBO=QT-(QRL+QRR)
      IF (QBO.GT.0.0) GO TO 7
      QBO=0.0
      CALL PRMSGZ (43,44,31,35)
C     PN-13* QRD > QT             ** ASSUMED WSU = H1N
      GO TO 31
    7 QRL=0.0
      QRR=0.0
      IF (FLOW1) GO TO 15
    8 CALL ERRQBO (QERR,IFLOW)
      IF (ABS(QERR).LE.QTOL*QT) GO TO 32
      IF (QERR.LT.0.0) GO TO 12
      IF (FLOW3) GO TO 10
      IF (SAVE(1).EQ.-9999.9) GO TO 9
      IF (SAVE(1).GE.GMAX) GO TO 9
      CALL PRMSGA (45,47,50,53,IFLOW)
C     PN-14* MIN QBO > QT (2)     ** ASSUMED QBO (1)
      GO TO 49
    9 IF (BELMX.GT.H1N) GO TO 11
   10 CALL PRMSGA (45,47,31,35,IFLOW)
C     PN-16* MIN QBO > QT (_)     ** ASSUMED WSU = H1N
      GO TO 31
   11 CALL PRMSGA (45,47,36,40,IFLOW)
C     PN-15* MIN QBO > QT (2)     ** ASSUMED WSU = BELMX
      GO TO 31
   12 SAVWS=WSU
      SAVVH=VHU
      WSU=GMAX
      CALL XSPROP (1,NOPTS,WSU,AU,KU,ALFU)
      VHU=ALFU*(QT/AU)**2/64.3
      CALL ERRQBO (QERR,IFLOW)
      IF (ABS(QERR).LE.QTOL*QT) GO TO 32
      IF (QERR.GT.0.0) GO TO 15
      CALL PRMSGA (48,50,54,56,IFLOW)
C     PN-17* MAX QBO < QT (_)     ** CHECKED QRD
      IF (.NOT.NOROAD) GO TO 33
      IF (FLOW3) GO TO 14
      IF (SAVE(1).EQ.-9999.9) GO TO 14
      IF (SAVE(1).GE.GMAX) GO TO 14
   13 CALL PRMSGZ (60,63,50,53)
C     PN-18* ROAD NOT CODED       ** ASSUMED QBO (1)
      GO TO 49
   14 CALL PRMSGZ (60,63,41,45)
C     PN-19* ROAD NOT CODED       ** ASSUMED WSU = GMAX
      GO TO 31
   15 QBO=QT
      GO TO (16,17,18), IFLOW
   16 VHB=(QBO/A2N)**2/64.3
      GO TO 19
   17 WSMIN=SAVWS
      WSMAX=GMAX
      GO TO 19
   18 DH=QBO**2/(41.2*ANET**2)
      WSU=SAVWS
      VHU=SAVVH
   19 DO 24 I=1,15
      IF (FLOW2) GO TO 21
      WSUB4=WSU
      VHUB4=VHU
      IF (FLOW1) GO TO 20
      WSU=WSD+DH-VHUB4
      GO TO 22
   20 CALL BWCOEF
      WSU=TEDS+KSTAR*VHB-VHUB4
      GO TO 22
   21 WSU=(WSMIN+WSMAX)/2.0
   22 CALL XSPROP (1,NOPTS,WSU,AU,KU,ALFU)
      VHU=ALFU*(QT/AU)**2/64.3
      IF (IFLOW.NE.2) GO TO 23
      CALL ERRQBO (QERR,IFLOW)
      IF (ABS(QERR).LE.QTOL*QT) GO TO 32
      IF (QERR.LT.0.0) WSMIN=WSU
      IF (QERR.GT.0.0) WSMAX=WSU
      GO TO 24
   23 WSU=WSU+VHUB4-VHU
      CALL XSPROP (1,NOPTS,WSU,AU,KU,ALFU)
      VHU=ALFU*(QT/AU)**2/64.3
      IF (ABS(WSUB4-WSU).LE.TOL) GO TO 32
   24 CONTINUE
      IF (.NOT.FLOW2) GO TO 25
      CALL PRMSGA (51,53,54,56,IFLOW)
C     PN-20* QTOL FAILURE (2)     ** CHECKED QRD
      GO TO 26
   25 CALL PRMSGA (6,8,54,56,IFLOW)
C     PN-21* TOL FAILURE (_)      ** CHECKED QRD
   26 IF (.NOT.NOROAD) GO TO 33
      GO TO (27,28,29), IFLOW
   27 IF (.NOT.MAYBE2) GO TO 29
      CALL PRMSGZ (60,63,46,49)
C     PN-22* ROAD NOT CODED       ** CHECKED QBO (2)
      GO TO 48
   28 IF (SAVE(1).EQ.-9999.9) GO TO 29
      IF (SAVE(1).GE.GMAX) GO TO 29
      IF (WSU.GE.GMAX) GO TO 13
      GO TO 30
   29 IF (WSU.LT.GMAX) GO TO 30
      WSU=GMAX
      CALL XSPROP (1,NOPTS,WSU,AU,KU,ALFU)
      GO TO 14
   30 CALL PRMSGZ (60,63,5,9)
C     PN-23* ROAD NOT CODED       ** USED COMPUTED WSU
      IF (FLOW1) RETURN
   31 M=999.
      E=999.
      KSTAR=999.
      RETURN
   32 IF (NOROAD) GO TO 47
      IF (WSU.LE.RMIN.AND.ABS(QBO/QT-1.0).LE.QTOL) GO TO 47
   33 IF (WSU.GT.GMAX) WSU=GMAX
   34 CALL ERRQ (QERR,IFLOW)
      IF (ABS(QERR).LE.QTOL*QT) GO TO 47
      IF (QERR.GT.0.0) GO TO 39
      IF (WSU.GE.GMAX) GO TO 35
      WSU=GMAX
      GO TO 34
   35 GO TO (36,37,38), IFLOW
   36 IF (.NOT.MAYBE2) GO TO 38
      CALL PRMSGA (54,56,46,49,IFLOW)
C     PN-24* MAX QTC < QT (1)     ** CHECKED QBO (2)
      GO TO 48
   37 IF (SAVE(1).EQ.-9999.9) GO TO 38
      IF (SAVE(1).GE.GMAX) GO TO 38
      CALL PRMSGA (54,56,50,53,IFLOW)
C     PN-25* MAX QTC < QT (2)     ** ASSUMED QBO (1)
      GO TO 49
   38 CALL PRMSGA (54,56,41,45,IFLOW)
C     PN-26* MAX QTC < QT (_)     ** ASSUMED WSU = GMAX
      GO TO 31
   39 WSMAX=WSU
      IF (FLOW1) GO TO 40
      IF (HMIN.LT.BELMX) HMIN=BELMX
   40 WSU=HMIN
      CALL ERRQ (QERR,IFLOW)
      IF (ABS(QERR).LE.QTOL*QT) GO TO 47
      IF (QERR.LT.0.0) GO TO 45
      GO TO (41,42,44), IFLOW
   41 CONTINUE
C     THIS SHOULD BE IMPOSSIBLE (PN-13 WOULD STOP COMPUTATIONS ALREADY)
C     HOWEVER, IF IT GETS HERE, JUST ----
      GO TO 48
   42 IF (SAVE(1).EQ.-9999.9) GO TO 43
      IF (SAVE(1).GE.GMAX) GO TO 43
      CALL PRMSGA (57,59,50,53,IFLOW)
C     PN-27* MIN QTC > QT (2)     ** ASSUMED QBO (1)
      GO TO 49
   43 IF (BELMX.LE.H1N) GO TO 44
      CALL PRMSGA (57,59,36,40,IFLOW)
C     PN-28* MIN QTC > QT (2)     ** ASSUMED WSU = BELMX
      GO TO 31
   44 CALL PRMSGA (57,59,31,35,IFLOW)
C     PN-29* MIN QTC > QT (_)     ** ASSUMED WSU = H1N
      IF (FLOW1) RETURN
      GO TO 31
   45 WSMIN=HMIN
      DO 46 I=1,15
      WSU=(WSMIN+WSMAX)/2.0
      CALL ERRQ (QERR,IFLOW)
      IF (ABS(QERR).LE.QTOL*QT) GO TO 47
      IF (QERR.GT.0.0) WSMAX=WSU
      IF (QERR.LT.0.0) WSMIN=WSU
   46 CONTINUE
      CALL PRMSGZ (51,53,5,9)
C     PN-30* QTOL FAILURE         ** USED COMPUTED WSU
   47 IF (.NOT.FLOW1) GO TO 31
      IF (.NOT.MAYBE2) RETURN
      IF (WSU.LT.BELMX) RETURN
      CALL PRMSGZ (64,67,46,49)
C     PN-31* WSU > BELMX (1)      ** CHECKED QBO (2)
      IF ((WSU-BEDEL)/Z.GE.1.1) GO TO 48
      CALL PRMSGZ (68,71,50,53)
C     PN-32* YU/Z < 1.1 (1)       ** ASSUMED QBO (1)
      RETURN
   48 SAVE(1)=WSU
      SAVE(2)=M
      SAVE(3)=E
      SAVE(4)=KSTAR
      SAVE(5)=QRL
      SAVE(6)=QRR
      SAVE(7)=QBO
      WSU=BELMX
      IF (BELMX.LT.H1N) WSU=H1N
      FLOW2=.TRUE.
      FLOW1=.FALSE.
      IFLOW=2
      GO TO 8
   49 WSU=SAVE(1)
      M=SAVE(2)
      E=SAVE(3)
      KSTAR=SAVE(4)
      QRL=SAVE(5)
      QRR=SAVE(6)
      QBO=SAVE(7)
      CALL XSPROP (1,NOPTS,WSU,AU,KU,ALFU)
      VHU=ALFU*(QT/AU)**2/64.3
      IFLOW=1
      RETURN
      END
      SUBROUTINE CD1CHK
C
      REAL N1,N3
      COMMON /PARM/ INX,INQ,ITOL,IDELH,IFN,NOQ,NXS
C-old INTEGER M/-1/
C-old REAL*8 B/'        '/,INV/'INVALID '/,HI/'HIGH    '/,LO/'LOW     '/
C-old1,LE1/') OR = Z'/,LE2/'ERO     '/,WR/'WRONG   '/,LT1/'IS LESS '/,LT
C-old22/'THAN    '/,NS1/'NOT SPEC'/,NS2/'IFIED   '/
C-old REAL*8 VNAME(8)/'SA      ','SEG     ','SAL     ','SEGL    ','SAR
C-old1   ','SEGR    ','NSA     ','NSEG    '/,SANM,SLNM,SRNM,NSNM,NGNM/'N
C-old2PTS    '/
      INTEGER M
C---end change
      COMMON /EDVAL/ ISN,ISEV29,NUM
      DIMENSION STA(1), EL(1), IS(1), BL(1), AB(1), N1(1), N3(1)
C-new
      CHARACTER*8 B, INV, HI, LO, LE1, LE2, WR, LT1, LT2, NS1, NS2,
     1            VNAME(8), SANM, SLNM, SRNM, NSNM, NGNM
      DATA M/-1/
      DATA B/'        '/, INV/'INVALID '/, HI/'HIGH    '/,
     1     LO/'LOW     '/, LE1/') OR = Z'/, LE2/'ERO     '/,
     2     WR/'WRONG   '/, LT1/'IS LESS '/, LT2/'THAN    '/,
     3     NS1/'NOT SPEC'/, NS2/'IFIED   '/
      DATA VNAME/'SA      ', 'SEG     ', 'SAL     ', 'SEGL    ',
     1           'SAR     ', 'SEGR    ', 'NSA     ', 'NSEG    '/,
     2     NGNM/'NPTS    '/
C---end change
      IF (INX.GT.0.AND.INX.LE.99) GO TO 10
      NXS=99
      CALL ERRMSG (1,'NXS     ',M,INV,B,B,M,NXS,B)
   10 IF (INQ.GT.0.AND.INQ.LE.20) GO TO 20
      INQ=20
      CALL ERRMSG (1,'NPR     ',M,INV,B,B,M,INQ,B)
   20 IF (ITOL.GT.0.AND.ITOL.LE.99) GO TO 30
C-old CALL ERRMSG (1,'TOL     ',M,INV,B,B,M,M,8H0.02'   )
      CALL ERRMSG (1,'TOL     ',M,INV,B,B,M,M,'0.02''   ')
C---end change
      ITOL=2
      GO TO 40
   30 IF (ITOL.LE.10) GO TO 40
      CALL ERRMSG (1,'TOL     ',M,HI,B,B,M,M,B)
   40 IF (IDELH.GT.0.AND.IDELH.LE.99) GO TO 50
      IDELH=5
C-old CALL ERRMSG (1,'DELTA H ',M,INV,B,B,M,M,8H0.5'    )
      CALL ERRMSG (1,'DELTA H ',M,INV,B,B,M,M,'0.5''    ')
C---end change
   50 IF (IFN.GT.0.AND.IFN.LE.20) GO TO 60
C-old CALL ERRMSG (1,'FN      ',M,INV,B,B,M,M,8H1.2     )
      CALL ERRMSG (1,'FN      ',M,INV,B,B,M,M,'1.2     ')
C---end change
      IFN=12
      RETURN
   60 IF (IFN.GT.15) CALL ERRMSG (1,'FN      ',M,HI,B,B,M,M,B)
      IF (IFN.LT.10) CALL ERRMSG (1,'FN      ',M,LO,B,B,M,M,B)
      RETURN
      ENTRY PVALCK(NG,STA,EL)
      MAXPTS=25
      ISN=0
      GO TO 80
      ENTRY RVALCK(NG,NS,STA,IS,EL,ISL,ISR)
      MAXPTS=50
      GO TO 70
      ENTRY XVALCK(NG,NS,STA,IS,EL,ISL,ISR,BL,AB,N1,N3)
      MAXPTS=200
   70 MAXSA=0
      NSNM=VNAME(ISN+6)
      SRNM=VNAME(ISN+4)
      SLNM=VNAME(ISN+2)
      SANM=VNAME(ISN)
   80 DO 100 I=1,MAXPTS
      IF (STA(I).EQ.-999999.) GO TO 110
      IF (ISN.NE.0) GO TO 90
      IF (STA(I).EQ.0.0.AND.EL(I).EQ.0.0) GO TO 110
      GO TO 100
   90 IF (STA(I).EQ.0.0.AND.IS(I).EQ.0.AND.EL(I).EQ.0.0) GO TO 110
  100 NCNT=I
  110 IF (NCNT.EQ.NG) GO TO 120
      NG=NCNT
      CALL ERRMSG (1,NGNM,M,WR,B,B,M,NG,B)
  120 GO TO (150,180), ISN
      DO 140 I=1,NG
      IF (STA(I).GT.0) GO TO 130
      CALL ERRMSG (2,'WIDTH   ',I,LE1,LE2,B,M,M,B)
  130 IF (I.EQ.1) GO TO 140
      IF (EL(I).GE.EL(I-1)) GO TO 140
      J=I-1
      CALL ERRMSG (2,'PIER EL.',I,LT1,LT2,'PIER EL.',J,M,B)
  140 CONTINUE
      RETURN
  150 DO 160 I=1,20
      IF (BL(I).EQ.-999.) GO TO 170
      IF (BL(I).EQ.0.0.AND.AB(I).EQ.0.0.AND.N1(I).EQ.0.0.AND.N3(I).EQ.0.
     10) GO TO 170
  160 NCNT=I
  170 IF (NCNT.EQ.NS) GO TO 180
      NS=NCNT
      CALL ERRMSG (1,NSNM,M,WR,B,B,M,NS,B)
  180 IF (IS(1).EQ.1) GO TO 190
      CALL ERRMSG (2,SANM,1,'MUST = 1',B,B,M,M,B)
  190 DO 240 I=2,NG
      J=I-1
      IF (STA(I).GE.STA(J)) GO TO 200
      CALL ERRMSG (ISEV29,'STATION ',I,LT1,LT2,'STATION ',J,M,B)
  200 IF (IS(I).GT.0.AND.IS(I).LE.NUM) GO TO 210
      IF (ISEV29.EQ.1.AND.IS(I).EQ.-9) GO TO 210
      CALL ERRMSG (2,SANM,I,INV,B,B,M,M,B)
  210 IF (IS(I).EQ.IS(J).OR.IS(I).EQ.IS(J)+1) GO TO 230
      IF (ISEV29.EQ.2) GO TO 220
      IF (IS(I).EQ.-9.OR.IS(J).EQ.-9) GO TO 230
  220 CALL ERRMSG (ISEV29,SANM,I,'OUT OF O','RDER    ',B,M,M,B)
  230 IF (IS(I).GT.MAXSA.AND.IS(I).LE.20) MAXSA=IS(I)
      IF (ISN.EQ.2) GO TO 240
      IF (IS(I).LE.NS) GO TO 240
      CALL ERRMSG (2,SANM,I,'GREATER ','THAN    ',NSNM,M,M,B)
  240 CONTINUE
      IF (MAXSA.EQ.NS) GO TO 270
      IF(NCNT.LT.MAXSA) GO TO 250
      NS=MAXSA
      ISEV=1
C *****     STATEMENT DELETED     *****     06/18/76     *****
      CALL ERRMSG (1,NSNM,M,'> MAX. V','ALUE OF ',SANM,M,NS,B)
      GO TO 270
  250 IF (ISN.EQ.2) GO TO 260
C *****     STATEMENT DELETED     *****     06/18/76     *****
      ISEV=2
  260 CALL ERRMSG (ISEV,NSNM,M,'< MAX. V','ALUE OF ',SANM,M,NS,B)
  270 IF (ISN.EQ.2) GO TO 380
      DO 370 I=1,NS
      IF (N1(I).GT.0.0.AND.N3(I).GT.0.0) GO TO 300
      IF (N1(I).GT.0.0.OR.N3(I).GT.0.0) GO TO 280
      CALL ERRMSG(2,'N1 & N3 ',I,NS1,NS2,B,M,M,B)
      GO TO 370
  280 IF (N1(I).GT.0.0) GO TO 290
      N1(I)=N3(I)
      CALL ERRMSG (1,'N1      ',I,NS1,NS2,B,M,M,'N1=N3   ')
      GO TO 300
  290 N3(I)=N1(I)
      CALL ERRMSG (1,'N3      ',I,NS1,NS2,B,M,M,'N3=N1   ')
  300 IF (BL(I).GE.0.0) GO TO 310
      CALL ERRMSG (1,'B       ',I,') ZERO  ',B,B,M,0,B)
  310 IF (AB(I).GT.BL(I)) GO TO 330
      IF (AB(I).EQ.BL(I)) GO TO 320
      CALL ERRMSG (1,'A       ',I,LT1,LT2,'B       ',I,M,'A=B     ')
  320 IF (N1(I).EQ.N3(I)) GO TO 330
      N3(I)=N1(I)
      CALL ERRMSG (1,'A       ',I,'IS EQUAL','TO      ','B       ',I,M,'
     1N3=N1   ')
  330 IF (N1(I).LT.0.2) GO TO 340
      CALL ERRMSG (1,'N1      ',I,HI,B,B,M,M,B)
  340 IF (N3(I).LT.0.2) GO TO 350
      CALL ERRMSG (1,'N3      ',I,HI,B,B,M,M,B)
  350 IF (N1(I).GT.0.015) GO TO 360
      CALL ERRMSG (1,'N1      ',I,LO,B,B,M,M,B)
  360 IF (N3(I).GT.0.015) GO TO 370
      CALL ERRMSG (1,'N3      ',I,LO,B,B,M,M,B)
  370 CONTINUE
      IF (ISEV29.EQ.1) RETURN
  380 IF (ISL.GT.0.AND.ISL.LE.NS) GO TO 390
      IF (ISL.EQ.99) GO TO 390
      ISL=99
      CALL ERRMSG (1,SLNM,M,INV,B,B,M,ISL,B)
  390 IF (ISR.GT.0.AND.ISR.LE.NS) GO TO 400
      IF (ISR.EQ.99) GO TO 400
      ISR=99
      CALL ERRMSG (1,SRNM,M,INV,B,B,M,ISR,B)
  400 IF (ISL.LT.(ISR-1+ISN/2).OR.ISL.EQ.99) GO TO 410
      CALL ERRMSG (2,SLNM,M,'IMPROPER','FOR     ',SRNM,M,M,B)
  410 RETURN
      END
      SUBROUTINE CHOPK (IGO,SECID,XI,SURCH,STALT,START)
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
C-old REAL N1,N3,SECID*8
      REAL N1, N3
      CHARACTER*8 SECID
C---end change
      INTEGER SA,KCHECK
      COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,DUM380
      COMMON /XSDATA/ S(200),SA(200),G(200),BL(20),AB(20),N1(20),N3(20)
      COMMON /XS3/ ISAL,ISAR
      COMMON /JPTS/ JLT,JRT
C-new
      SUMK=0
C---end change
      JLT=0
      JRT=0
C     METHOD=VER,VSA,VHD,HOR,NOE ***
      GO TO (30,10,20,20), IGO
   10 CALL ENDPTS (JLT,JRT,NOPTS,ISAL,ISAR,SA)
      IF (JLT.EQ.0) JLT=1
      IF (JRT.EQ.0) JRT=NOPTS
      GO TO 30
   20 CALL REVXS (STALT,START)
      IF (IGO.EQ.4) GO TO 230
   30 CALL XSPROP (1,NOPTS,XI,SUMA,KORIG,ALFA)
      XI=XI+SURCH
      CALL XSPROP (1,NOPTS,XI,SUMA,KTWY,ALFA)
      KENC=KTWY-0.5*(KTWY-KORIG)
      ILT=1
      IRT=NOPTS
      IF (JLT.EQ.0) GO TO 40
      IF (JLT.EQ.1) GO TO 130
      CALL XSPROP (JLT,NOPTS,XI,SUMA,KWOL,ALFA)
      IF (KWOL.GT.KENC) GO TO 130
   40 IF (JRT.EQ.0) GO TO 50
      CALL XSPROP (1,JRT,XI,SUMA,KWOR,ALFA)
      IF (KWOR.LT.KENC) GO TO 50
      KENC=KORIG
      IRT=JRT
      IF (JLT.EQ.0) GO TO 50
      CALL XSPROP (JLT,JRT,XI,SUMA,KLIM,ALFA)
      IF (KLIM.LT.KENC) GO TO 50
      GO TO 230
   50 ITRIED=0
   60 ILT=ILT+1
      IERR=KCHECK(XI,ILT,IRT,KORIG,KENC,SUMK)
      GO TO (70,120,60), IERR
   70 ILT=ILT-1
      GORIG=G(ILT)
      SORIG=S(ILT)
   80 GLT=GORIG
      SLT=SORIG
      GRT=G(ILT+1)
      SRT=S(ILT+1)
      DO 110 IH=1,10
      S(ILT)=(SLT+SRT)/2.
      G(ILT)=(GLT+GRT)/2.
      IERR=KCHECK(XI,ILT,IRT,KORIG,KENC,SUMK)
      GO TO (100,120,90), IERR
   90 SLT=S(ILT)
      GLT=G(ILT)
      GO TO 110
  100 SRT=S(ILT)
      GRT=G(ILT)
  110 CONTINUE
      IF (ITRIED.EQ.1) GO TO 120
      SA(ILT)=SA(ILT+1)
      ITRIED=1
      GO TO 80
  120 JLT=ILT
      GO TO 140
  130 ILT=JLT
  140 KENC=KORIG
      IF (JRT.EQ.0) GO TO 150
      IF (JRT.EQ.NOPTS) GO TO 230
      CALL XSPROP (JLT,JRT,XI,SUMA,KLIM,ALFA)
      IF (KLIM.GT.KENC) GO TO 230
      IF (ABS((KENC-KLIM)/KORIG).LE.0.0005) GO TO 230
  150 ITRIED=0
  160 IRT=IRT-1
      IF (IRT.EQ.ILT) GO TO 170
      IERR=KCHECK(XI,ILT,IRT,KORIG,KENC,SUMK)
      GO TO (170,220,160), IERR
  170 IRT=IRT+1
      GORIG=G(IRT)
      SORIG=S(IRT)
  180 GRT=GORIG
      SRT=SORIG
      GLT=G(IRT-1)
      SLT=S(IRT-1)
      DO 210 IH=1,10
      S(IRT)=(SLT+SRT)/2.
      G(IRT)=(GLT+GRT)/2.
      IERR=KCHECK(XI,ILT,IRT,KORIG,KENC,SUMK)
      GO TO (190,220,200), IERR
  190 SLT=S(IRT)
      GLT=G(IRT)
      GO TO 210
  200 SRT=S(IRT)
      GRT=G(IRT)
  210 CONTINUE
      IF (ITRIED.EQ.1) GO TO 220
      SA(IRT)=SA(IRT-1)
      ITRIED=1
      GO TO 180
  220 JRT=IRT
  230 NOPTS=JRT-JLT+1
      DO 240 I=1,NOPTS
      S(I)=S(I-1+JLT)
      G(I)=G(I-1+JLT)
  240 SA(I)=SA(I-1+JLT)
      GMIN=THEMIN(2,NOPTS,G)
      RETURN
      END
      SUBROUTINE DATAED (NXSHYD,NXSKEP,NXSPRO,FLUSH)
      LOGICAL ABORTX,ABORTP,FLUSH
C-old INTEGER M/-1/,DATA,ABUT,WW,SKEW,SA,PIER
C-old REAL*8 B/'        '/,INV/'INVALID '/,WR/'WRONG   '/,SECID
      INTEGER M,DATA,ABUT,WW,SKEW,SA,PIER
      CHARACTER*8 B,INV,WR,SECID
C---end change
      REAL N1,N3
      COMMON /IDSEC/ SECID
      COMMON /EDVAL/ ISN,ISEV29,NUM
      COMMON /ABX/ ABORTX
      COMMON /PARM/ INX,INQ,ITOL,IDELH,IFN,NOQ,NXS
      COMMON /IDAT/ IDATA(705)
      COMMON /XS3/ ISAL,ISAR
      COMMON /NRAYS/ NSEQ3(99),NDATA(99),NFILE(99),NREC(99)
      COMMON /AV/ IR11,IR12,IR13
      COMMON /XSDATA/ S(200),SA(200),G(200),BL(20),AB(20),N1(20),N3(20)
      COMMON /RDATA/ RDEL(50),RDSTA(50),ISEG(50),IT(10),RDWID,NGRD
      COMMON /FLAG/ DATA
C-old COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,CD3C80
C-old COMMON /BP1/ SKEW,PIER,ABUT,WW,SUBEL,BELDUM
      COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,DUM380
      CHARACTER*1 CD3C80
      COMMON /XS1C/ CD3C80
      COMMON /BP1/ SKEW,PIER,ABUT,WW,SUBEL,BELMX
C---end change
      COMMON /BP4/ RGLMN,RGRMN,QTOL,RDIST
      COMMON /BP6/ ISEGL,ISEGR,NSEG
      COMMON /PDATA/ PIERW(25),PIEREL(25)
Cunused COMMON /PIERA/ ELPR(25),APR(25),NPA
      DIMENSION Q(20)
C-new
      DATA M/-1/, B/'        '/, INV/'INVALID '/, WR/'WRONG   '/
C---end change
      QTOL=0.0
      IR11=1
      ABORTP=.FALSE.
      IOUT=0
      DATA=0
      LDIST=-1000000
      SECID=B
      CALL INITEM
      CALL CD1CHK
      NOQ=INQ
      DO 360 IXS=1,NXSKEP
      IF (DATA.NE.9) LDATA=DATA
      ISN=1
      ISEV29=2
      NUM=20
      ABORTX=.FALSE.
C-old READ (11'IXS) NDPTS,ISEQ3,SECID,DATA,NOPTS,(IDATA(JJ),JJ=1,NDPTS),
C-old$      CD3C80
C-old   IR11 = IR11 + 1                                           /*************
      READ (11,REC=IXS) NDPTS, ISEQ3, SECID, DATA, NOPTS,
     $                  (IDATA(JJ),JJ=1,NDPTS), CD3C80
        IR11 = IR11 + 1
C---end change
      IF (IXS.GT.1) GO TO 10
      IF (DATA.EQ.1.OR.DATA.EQ.9) GO TO 120
      DATA=1
      CALL ERRMSG (1,'TYPE    ',M,WR,B,B,M,DATA,B)
      GO TO 120
   10 IF (DATA.EQ.9) GO TO 120
      GO TO (20,60,320,240,40), DATA
      IF (DATA.NE.0) GO TO 30
   20 IF (LDATA.LT.2.OR.LDATA.GT.4) GO TO 120
      GO TO 50
   30 DATA=0
      CALL ERRMSG (1,'TYPE     ',M,INV,B,B,M,DATA,B)
      GO TO 120
   40 IF (LDATA.GE.2.AND.LDATA.LE.4) GO TO 120
   50 CALL ERRMSG (2,'TYPE    ',M,WR,B,B,M,M,B)
      ABORTX=.FALSE.
      CALL SETNXS (IOUT,NXSPRO,ABORTP,FLUSH)
C
      GO TO (120,70,330,250,120), DATA
      GO TO 120
   60 IF (LDATA.GE.2.AND.LDATA.LE.4) GO TO 50
   70 ABUT=IDATA(7)
      IF (ABUT.EQ.0.OR.ABUT.EQ.1) GO TO 80
      ABUT=1
      CALL ERRMSG (1,'ABUT    ',M,INV,B,B,M,ABUT,B)
   80 WW=IDATA(6)
      IF (WW.GT.0.AND.WW.LT.5) GO TO 90
      WW=1
      CALL ERRMSG (1,'WW      ',M,INV,B,B,M,WW,B)
   90 SUBEL=FLOAT(IDATA(5))/10.0
      SKEW=IDATA(4)
      I5BEG=8
      IF (SKEW.EQ.0.OR.SKEW.EQ.15.OR.SKEW.EQ.30.OR.SKEW.EQ.45) GO TO 130
      DO 100 I=1,3
      IF (SKEW.GT.(15*I-8)) GO TO 100
      J=I-1
      GO TO 110
  100 CONTINUE
      J=3
  110 SKEW=15*J
      CALL ERRMSG (1,'SKEW    ',M,INV,B,B,M,SKEW,B)
      GO TO 130
  120 ISAR=IDATA(5)
      ISAL=IDATA(4)
      I5BEG=6
  130 IDIST=IDATA(3)
      HSUBO=IDATA(2)
      NSA=IDATA(1)
      IF (DATA.EQ.9) GO TO 190
      IF (DATA.NE.2) GO TO 140
      IF (IDIST.EQ.LDIST) GO TO 160
      IDIST=LDIST
      CALL ERRMSG (1,'DISTANCE',M,WR,B,B,M,M,'EXIT SRD')
      GO TO 160
  140 IF (IDIST.GT.LDIST) GO TO 150
      CALL ERRMSG (2,'DISTANCE',M,WR,B,B,M,M,B)
      ABORTX=.FALSE.
      CALL SETNXS (IOUT,NXSPRO,ABORTP,FLUSH)
      GO TO 160
  150 LDIST=IDIST
  160 IF (DATA.NE.1) GO TO 190
      I5BEG=26
      DO 170 IQ=1,20
      Q(IQ)=IDATA(IQ+5)
      IF (Q(IQ).LE.0.0) GO TO 180
  170 CONTINUE
      IQ=21
  180 JNQ=IQ-1
      IF (JNQ.GE.NOQ) GO TO 190
      NOQ=JNQ
      CALL ERRMSG (1,'NPR     ',M,WR,B,B,M,JNQ,B)
  190 CALL FLOTXS (I5BEG)
      IF (DATA.EQ.2.OR.DATA.EQ.9) ISEV29=1
      CALL XVALCK (NOPTS,NSA,S,SA,G,ISAL,ISAR,BL,AB,N1,N3)
      GMIN=THEMIN(2,NOPTS,G)
      GMAX=THEMAX(NOPTS,G)
      IF (HSUBO.GT.GMIN) GO TO 220
      HMIN=INT(GMIN)
      I=0
  200 I=I+1
      HSUBO=HMIN+FLOAT(I*IDELH)/10.0+0.00005
      IF (HSUBO.GT.GMIN+0.05) GO TO 210
      GO TO 200
  210 CALL ERRMSG (1,'HSUBO   ',M,'IS LESS ','THAN    ','GMIN    ',M,M,'
     1> GMIN  ')
  220 IF (ABORTX) GO TO 350
  230 IOUT=IOUT+1
      NREC(IOUT)=IOUT
      NFILE(IOUT)=11
      NSEQ3(IOUT)=ISEQ3
      NDATA(IOUT)=DATA
      CALL DWRITE (DATA,11,IOUT,SECID,Q,*360)
  240 IF (LDATA.LT.2.OR.LDATA.GT.3) GO TO 50
  250 NSEG=IDATA(1)
      RDWID=IDATA(2)
      IF (RDWID.GT.0.0) GO TO 260
      CALL ERRMSG (2,'RDWID   ',M,') OR = Z','ERO     ',B,M,M,B)
  260 ISEGL=IDATA(3)
      ISEGR=IDATA(4)
      NGRD=NOPTS
      ISN=2
      NUM=10
      DO 270 I=1,NUM
      IT(I)=IDATA(I+4)
  270 CONTINUE
      IF (NSEG.GT.0.AND.NSEG.LE.10) GO TO 280
      NSEG=10
      CALL ERRMSG (1,'NSEG    ',M,INV,B,B,M,NSEG,B)
  280 QTOL=FLOAT(IDATA(15))/100.0
      IF (QTOL.GT.0.0) GO TO 290
      QTOL=0.01
      CALL ERRMSG (1,'QTOL    ',M,INV,B,B,M,M,'1 (     ')
  290 CALL FLOTRD (16)
      CALL RVALCK (NGRD,NSEG,RDSTA,ISEG,RDEL,ISEGL,ISEGR)
      DO 300 I=1,NSEG
      IF (IT(I).GT.0.AND.IT(I).LT.3) GO TO 300
      IT(I)=1
      CALL ERRMSG (1,'T       ',I,INV,B,B,M,1,B)
  300 CONTINUE
C
      RGLMN=9999.9
      RGRMN=9999.9
      CALL ENDPTS (JL,JR,NGRD,ISEGL,ISEGR,ISEG)
      IF (JL.EQ.0) GO TO 310
      RGLMN=THEMIN(2,JL,RDEL)
  310 IF (JR.EQ.0) GO TO 220
      RGRMN=THEMIN(JR+1,NGRD,RDEL)
      GO TO 220
  320 IF (LDATA.NE.2) GO TO 50
  330 PIER=IDATA(1)
      IF (PIER.GE.1.AND.PIER.LE.8) GO TO 340
      PIER=1
      CALL ERRMSG (1,'PIER    ',M,WR,B,B,M,PIER,B)
  340 CALL FLOTPR
      CALL PVALCK (NOPTS,PIERW,PIEREL)
      IF (ABORTX) GO TO 350
      CALL PAREA
      GO TO 230
  350 CALL SETNXS (IOUT,NXSPRO,ABORTP,FLUSH)
  360 CONTINUE
      NXSHYD=IOUT
  370 IF (NXSPRO.LE.0) GO TO 380
      LDATA=NDATA(NXSPRO)
      IF (LDATA.LT.2.OR.LDATA.EQ.5) GO TO 380
      NXSPRO=NXSPRO-1
      GO TO 370
  380 RETURN
      END
      SUBROUTINE DATAIN (NXSKEP,NXSPRO,NXSFND)
C-old LOGICAL ENDATA,CD1SAV,ABORTP,NO789,NOTBL,FLUSH,JOB,REPEAT,RUNIT,JO
C-old1B1
C-old REAL*8 SECID,ANON*4/'   ?'/
C-old INTEGER JGO(7)/'VER','VSA','VHD','HOR','NOE','ADD','END'/
C-old INTEGER B1(8)/7,49,-58,73,3,-74,80,1/,B24(7)/6,-15,78,7,-79,80,1/,
C-old1B3ALL(4)/3,14,16,20/,B30159(9)/8,23,28,-36,42,3,-43,80,1/,B32(14)/
C-old213,23,28,36,-37,42,1,45,-51,55,2,-56,80,1/,B33(8)/7,-21,50,1,53,-5
C-old34,80,1/,B34(17)/16,23,28,-29,36,1,39,42,-43,51,1,-53,73,2,-74,80,1
C-old4/,B5(13)/12,-9,11,1,-16,72,14,-19,75,14,-25,67,14/,B6(16)/15,-11,6
C-old57,14,-14,70,14,-18,74,14,-22,78,14,-79,80,1/,M/'M'/,U/'U'/,BLANK/'
C-old6 '/,IDUM/80/,DATA,B53(13)/12,-19,75,14,-9,11,1,-16,72,14,-25,67,14
C-old7/
      LOGICAL ENDATA,CD1SAV,ABORTP,NO789,FLUSH,JOB,REPEAT,RUNIT,JOB1
      CHARACTER SECID*8, ANON*4, JGO(7)*3, IMTHD*3, X*1, COL80*1
      INTEGER B1(8), B24(7), B3ALL(4), B30159(9), B32(14), B33(8),
     1        B34(17), B5(13), B6(16), IDUM, DATA, B53(13)
      CHARACTER*1 M, U, BLANK
C---end change
      COMMON /FLAG/ DATA
      COMMON /AV/ IR11,IR12,IR13
C-new
      CHARACTER*4 STRID, GSID, FWID
C---end change
      COMMON /ID/ STRID(10),GSID(2),FWID(5)
      COMMON /PARM/ INX,INQ,ITOL,IDELH,IFN,NOQ,NXS
      COMMON /IDSEC/ SECID
      COMMON /FLD/ METHOD(99),I3SEQ(99),Y(99),STAR(99),STAL(99),ELEV(99)
C-old COMMON /INALF/ ICARD,INPUTA(80),IBAD(80),JCARD,LCARD,NOTBL,LINES
      CHARACTER*1 INPUTA, IBAD
      COMMON /INALFC/ INPUTA(80), IBAD(80)
      INTEGER ICARD, JCARD, LCARD, LINES
      LOGICAL NOTBL
      COMMON /INALF/ ICARD, JCARD, LCARD, LINES, NOTBL
C---end change
      COMMON /LOGPTR/ CD1SAV,ENDATA,NO789,FLUSH,RUNIT,JOB1
      COMMON /IWS/ WSI(20)
      DIMENSION IDATA(705), IRUN(20), IELV(20)
      DATA REPEAT/.FALSE./,X/'X'/
C
C-new
      DATA ANON/'   ?'/
      DATA JGO/'VER','VSA','VHD','HOR','NOE','ADD','END'/
      DATA B1/7,49,-58,73,3,-74,80,1/, B24/6,-15,78,7,-79,80,1/,
     1     B3ALL/3,14,16,20/, B30159/8,23,28,-36,42,3,-43,80,1/,
     2     B32/13,23,28,36,-37,42,1,45,-51,55,2,-56,80,1/,
     3     B33/7,-21,50,1,53,-54,80,1/,
     4     B34/16,23,28,-29,36,1,39,42,-43,51,1,-53,73,2,-74,80,1/,
     5     B5/12,-9,11,1,-16,72,14,-19,75,14,-25,67,14/,
     6     B6/15,-11,67,14,-14,70,14,-18,74,14,-22,78,14,-79,80,1/,
     7     M/'M'/, U/'U'/, BLANK/' '/,IDUM/80/,
     8     B53/12,-19,75,14,-9,11,1,-16,72,14,-25,67,14/
      ISEQ=0
C---end change
      LSEQ=-100000
      ABORTP=.FALSE.
      NO789=.TRUE.
      JOB=.FALSE.
      NOTBL=.TRUE.
      RUNIT=.TRUE.
      DO 10 I=1,20
   10 WSI(I)=-100000
      IR11=1
      NXSPRO=-1
      INX=0
      INQ=0
      IFN=0
      ITOL=0
      IDELH=0
      NXSKEP=0
      NXSFND=0
C-new
      I9MAX=0
C---end change
      CALL INITAL
      ICARD=1
      KARDOR=7
      IF (JOB1) KARDOR=0
      IF (.NOT.FLUSH) GO TO 40
      FLUSH=.FALSE.
      IF (JCARD.LT.1.OR.JCARD.GT.3) GO TO 570
      IF (JCARD.EQ.1) GO TO 50
   20 DO 30 I=1,10
   30 STRID(I)=ANON
      GSID(1)=ANON
      GSID(2)=ANON
      JOB=.TRUE.
      IF (JCARD.EQ.3) GO TO 120
      GO TO 80
   40 IF (.NOT.CD1SAV) GO TO 60
   50 CD1SAV=.FALSE.
      GO TO 70
   60 CALL ALPHIN (*520,*610,*520)
   70 CALL EDITCH (7,59)
      JOB=.TRUE.
      CALL RPTMSG (REPEAT)
      CALL EDITBJ (B1,72,*500)
      BACKSPACE 99
      READ (99,640) LSEQ,STRID,GSID,INX,INQ,ITOL,IDELH,IFN,COL80
      IF (COL80.EQ.X) RUNIT=.FALSE.
   80 ICARD=2
      KARDOR=0
      NXS=INX
      NOQ=INQ
      IF (NXS.LE.0.OR.NXS.GT.99) NXS=99
      IF (NOQ.LE.0.OR.NOQ.GT.20) NOQ=20
      LCOL=77
      DO 110 J=1,20,10
      IF (JCARD.EQ.2.AND.J.EQ.1) GO TO 90
      CALL ALPHIN (*120,*490,*520)
   90 CALL RPTMSG (REPEAT)
      CALL EDITCH (77,IDUM)
      J2=J+9
      IF (J2.LE.NOQ) GO TO 100
      LCOL=77-7*(J2-NOQ)
      IF (LCOL.LT.7) LCOL=7
  100 CALL EDITBJ (B24,LCOL,*500)
C-old BACKSPACE 99                        /********* 83.180
      BACKSPACE 99
C---end change
      READ (99,650) ISEQ,(WSI(JJ),JJ=J,J2)
      CALL SEQCHK (LSEQ,ISEQ)
  110 CONTINUE
  120 ICARD=3
      KARDOR=0
      IF (JCARD.EQ.3) GO TO 130
      CALL ALPHIN (*520,*480,*510)
  130 NXSFND=NXSFND+1
      IDATA(6)=-999
      CALL EDITCH (7,15)
      CALL EDITBJ (B3ALL,IDUM,*500)
C-old BACKSPACE 99                           /************* 83.180
      BACKSPACE 99
C---end change
      READ (99,660) ISEQ,SECID,DATA,NOPTS
C************************
      ISEQ3=ISEQ
      CALL SEQCHK (LSEQ,ISEQ)
C**************************
      IF (IR11.EQ.1) GO TO 190
      GO TO (190,140,150,330,190,520,520,520,190), DATA
      GO TO 190
  140 CALL EDITBJ (B32,54,*500)
C-old BACKSPACE 99                          /*********    83.180
      BACKSPACE 99
C---end change
      READ (99,670) (IDATA(JJ),JJ=1,7),CD3C80
      I5BEG=8
      GO TO 230
  150 CALL EDITBJ (B33,52,*500)
C-old BACKSPACE 99                           /********** 83.180
      BACKSPACE 99
C---end change
      READ (99,680) IDATA(1)
      I5BEG=2
      J2=1
      I5END=J2+2*NOPTS
      LCOL=80
      ICARD=5
      KARDOR=3
      DO 180 J=1,25,5
      IDATA(J2+1)=-999999
      IF (JCARD.EQ.5.AND.J.EQ.1) GO TO 160
      CALL ALPHIN (*370,*490,*370)
  160 CALL EDITCH (80,IDUM)
      J1=J2+1
      J2=J1+9
      IF (J2.LE.I5END) GO TO 170
      LCOL=80-14*(J2-I5END)/2
      IF (LCOL.LT.7) LCOL=7
  170 CALL EDITBJ (B53,LCOL,*500)
C-old BACKSPACE 99                                /*********** 83.180
      BACKSPACE 99
C---end change
      READ (99,690) ISEQ,(IDATA(JJ),JJ=J1,J2)
      CALL SEQCHK (LSEQ,ISEQ)
  180 CONTINUE
      GO TO 370
  190 CALL EDITBJ (B30159,41,*500)
C-old BACKSPACE 99                    /*************83.180
      BACKSPACE 99
C---end change
      READ (99,700) (IDATA(JJ),JJ=1,5),CD3C80
      I5BEG=6
      IF (IR11.EQ.1.AND.DATA.NE.9) GO TO 200
      IF (DATA.NE.1) GO TO 230
  200 J2=5
      I5BEG=26
      ICARD=4
      LCOL=77
      DO 220 J=1,20,10
      CALL ALPHIN (*230,*490,*520)
      CALL EDITCH (77,IDUM)
      J1=J2+1
      J2=J1+9
      IDATA(J2+1)=-999
      IF (J2.LE.NOQ+5) GO TO 210
      LCOL=77-7*(J2-(NOQ+5))
      IF (LCOL.LT.7) LCOL=7
  210 CALL EDITBJ (B24,LCOL,*500)
C-old BACKSPACE 99                      /************** 83.180
      BACKSPACE 99
C---end change
      READ (99,710) ISEQ,(IDATA(JJ),JJ=J1,J2)
      CALL SEQCHK (LSEQ,ISEQ)
  220 CONTINUE
  230 ICARD=5
      KARDOR=6
      J2=I5BEG-1
      I5END=J2+3*NOPTS
      LCOL=80
      DO 260 J=1,200,5
      IDATA(J2+1)=-999999
      IF (JCARD.EQ.5.AND.J.EQ.1) GO TO 240
      CALL ALPHIN (*270,*490,*520)
  240 CALL EDITCH (80,IDUM)
      J1=J2+1
      J2=J1+14
      IF (J2.LE.I5END) GO TO 250
      LCOL=80-14*(J2-I5END)/3
      IF (LCOL.LT.7) LCOL=7
  250 CALL EDITBJ (B5,LCOL,*500)
C-old BACKSPACE 99                      /************** 83.180
      BACKSPACE 99
C---end change
      READ (99,720) ISEQ,(IDATA(JJ),JJ=J1,J2)
      CALL SEQCHK (LSEQ,ISEQ)
  260 CONTINUE
  270 ICARD=6
      KARDOR=3
      LCOL=77
      NSA=IDATA(1)
      J2=I5BEG+599
      I6END=J2+4*NSA
      DO 310 J=1,20,5
      IF (J2+1.GT.705) GO TO 280
      IDATA(J2+1)=-999
  280 IF (JCARD.EQ.6.AND.J.EQ.1) GO TO 290
      CALL ALPHIN (*380,*320,*380)
  290 CALL EDITCH (77,IDUM)
      J1=J2+1
      J2=J1+19
      IF (J2.LE.I6END) GO TO 300
      LCOL=77-14*(J2-I6END)/4
      IF (LCOL.LT.7) LCOL=7
  300 CALL EDITBJ (B6,LCOL,*500)
C-old BACKSPACE 99                      /************** 83.180
      BACKSPACE 99
C---end change
      READ (99,730) ISEQ,(IDATA(JJ),JJ=J1,J2)
      CALL SEQCHK (LSEQ,ISEQ)
  310 CONTINUE
      GO TO 380
  320 IF (LCARD.NE.6) GO TO 490
      ENDATA=.TRUE.
      GO TO 380
  330 CALL EDITBJ (B34,72,*500)
C-old BACKSPACE 99                      /************** 83.180
      BACKSPACE 99
C---end change
      READ (99,740) (IDATA(JJ),JJ=1,15)
      NSEG=IDATA(1)
      ICOL=52+2*NSEG
      DO 340 I=ICOL,70,2
      IF (IBAD(I).EQ.M) IBAD(I)=BLANK
      IF (INPUTA(I).NE.BLANK) IBAD(I)=U
  340 CONTINUE
      CALL EDITSP ( 72 ,*500)
      I5BEG=16
      J2=15
      I5END=J2+3*NOPTS
      ICARD=5
      KARDOR=3
      LCOL=80
      DO 360 J=1,50,5
      IDATA(J2+1)=-999999
      CALL ALPHIN (*370,*490,*370)
      CALL EDITCH (80,IDUM)
      J1=J2+1
      J2=J1+14
      IF (J2.LE.I5END) GO TO 350
      LCOL=80-14*(J2-I5END)/3
      IF (LCOL.LT.7) LCOL=7
  350 CALL EDITBJ (B5,LCOL,*500)
C-old BACKSPACE 99                      /************** 83.180
      BACKSPACE 99
C---end change
      READ (99,720) ISEQ,(IDATA(JJ),JJ=J1,J2)
      CALL SEQCHK (LSEQ,ISEQ)
  360 CONTINUE
  370 IF (LCARD.EQ.5) GO TO 380
      GO TO 520
  380 IF(J2.LT.705) J2=J2+1
C-old WRITE (11'IR11) J2,ISEQ3,SECID,DATA,NOPTS,(IDATA(JJ),JJ=1,J2),
C-old$     CD3C80
C-old   IR11 = IR11 + 1                        /********************
      WRITE (11,REC=IR11) J2,ISEQ3,SECID,DATA,NOPTS,(IDATA(JJ),JJ=1,J2),
     $     CD3C80
        IR11 = IR11 + 1
C---end change
      IF (ENDATA) GO TO 620
      IF (JCARD.LT.1.OR.JCARD.GT.7) GO TO 520
      IF(JCARD.EQ.ICARD) GO TO 120
      GO TO (600,520,120,520,520,120,390), JCARD
  390 NO789=.FALSE.
      GO TO 620
      ENTRY IN78(IRUN,IELV)
      CALL INITAL
      WRITE (6,630) INPUTA
C-old BACKSPACE 99                      /************** 83.180
      BACKSPACE 99
C---end change
      READ (99,750) ISEQ,IRUN
      CALL SEQCHK (LSEQ,ISEQ)
      ICARD=8
      CALL ALPHIN (*470,*460,*470)
C-old BACKSPACE 99                      /************** 83.180
      BACKSPACE 99
C---end change
      READ (99,750) ISEQ,IELV
      CALL SEQCHK (LSEQ,ISEQ)
      RETURN
      ENTRY IN9
      CALL INITAL
      ICARD=9
      I9=0
  400 CALL ALPHIN (*470,*460,*470)
      IF (I9.NE.0) GO TO 420
C-old BACKSPACE 99                      /************** 83.180
      BACKSPACE 99
C---end change
      READ (99,760) ISEQ,IMTHD,YINC
      IF (IMTHD.NE.JGO(6)) GO TO 420
      CALL SEQCHK (LSEQ,ISEQ)
      DO 410 I9=1,I9MAX
      IF (METHOD(I9).GT.3) GO TO 410
      Y(I9)=Y(I9)+YINC
  410 CONTINUE
      CALL ALPHIN (*470,*460,*470)
C-old BACKSPACE 99                      /************** 83.180
      BACKSPACE 99
C---end change
      READ (99,770) ISEQ,IMTHD,FWID
      CALL SEQCHK (LSEQ,ISEQ)
      IF (IMTHD.NE.JGO(7)) GO TO 440
      RETURN
  420 I9MAX=I9
      I9=I9+1
C-old BACKSPACE 99                      /************** 83.180
      BACKSPACE 99
C---end change
      READ (99,780) ISEQ,I3SEQ(I9),IMTHD,Y(I9),STAL(I9),STAR(I9),ELEV(I9
     1),FWID
      CALL SEQCHK (LSEQ,ISEQ)
      IF (IMTHD.EQ.JGO(7)) GO TO 450
      DO 430 I=1,5
      IF (IMTHD.NE.JGO(I)) GO TO 430
      METHOD(I9)=I
      GO TO 400
  430 CONTINUE
  440 WRITE (6,790)
      LINES=LINES+3
      GO TO 470
  450 I3SEQ(I9)=100000
      RETURN
  460 ENDATA=.TRUE.
      WRITE (6,800)
  470 FLUSH=.TRUE.
      RETURN
  480 IF (LCARD.EQ.6) GO TO 610
  490 WRITE (6,800)
      GO TO 610
  500 WRITE (6,810)
      LINES=LINES+1
      ICARD=3
      GO TO 550
  510 IF (JCARD.EQ.1) GO TO 600
      IF (JCARD.EQ.7) GO TO 390
  520 IF (JCARD.LT.1.OR.(JCARD.GE.3.AND.JCARD.NE.7)) GO TO 530
      REPEAT=.TRUE.
      WRITE (6,630) INPUTA
  530 WRITE (6,820) ICARD
      IF (KARDOR.EQ.0) GO TO 540
      WRITE (6,830) KARDOR
      GO TO 550
  540 WRITE (6,840)
  550 IF (.NOT.JOB) GO TO 570
      IF (ABORTP) GO TO 560
      ABORTP=.TRUE.
      NXSPRO=IR11-1
      FLUSH=.TRUE.
  560 IF (ICARD.EQ.3) GO TO 570
      IF (ICARD.EQ.4.AND.JCARD.EQ.5) GO TO 230
      IF (JCARD.EQ.3) GO TO 120
      IF (JCARD.EQ.1.OR.JCARD.EQ.2) GO TO 620
  570 CALL GET123 (*610)
      IF (JOB) GO TO 580
      GO TO (70,20,20), JCARD
  580 GO TO (600,590,120), JCARD
  590 FLUSH=.TRUE.
      GO TO 620
  600 CD1SAV=.TRUE.
      GO TO 620
  610 ENDATA=.TRUE.
  620 NXSKEP=IR11-1
      IF (NXSPRO.LT.0) NXSPRO=NXSKEP
      RETURN
  630 FORMAT (' ',80A1)
  640 FORMAT (2X,I5,1X,10A4,1X,2A4,5(1X,I2),7X,A1)
  650 FORMAT (2X,I5,10(1X,F6.2))
  660 FORMAT (2X,I5,1X,A5,1X,I1,1X,I3)
  670 FORMAT (20X,I2,1X,I4,1X,I7,7X,I2,1X,I5,2(1X,I1),25X,A1)
  680 FORMAT (51X,I1)
  690 FORMAT (2X,I5,3X,5(I5,4X,I5))
  700 FORMAT (20X,I2,1X,I4,1X,I7,2(1X,I2),38X,A1)
  710 FORMAT (2X,I5,10I7)
  720 FORMAT (2X,I5,3X,5(I5,1X,I2,1X,I5))
  730 FORMAT (2X,I5,5(2(1X,I2),2(1X,I3)))
  740 FORMAT (20X,I2,1X,I4,8X,2(1X,I2),9X,11(1X,I1))
  750 FORMAT (2X,I5,33X,20(1X,I1))
  760 FORMAT (2X,I5,7X,A3,1X,F3.2)
  770 FORMAT (2X,I5,7X,A3,22X,5A4)
  780 FORMAT (2X,2(I5,1X),A3,1X,F3.2,2F5.0,1X,F6.2,1X,5A4)
  790 FORMAT (' **INVALID FW METHOD**')
  800 FORMAT (' **PREMATURE END OF DATA**')
  810 FORMAT (' **INVALID CHARACTER(S) ON PRECEDING CARD**')
  820 FORMAT ('+',82X,'EXPECTED #',I1)
  830 FORMAT ('+',94X,'OR #',I1,' CARD')
  840 FORMAT ('+',94X,'CARD')
      END
      SUBROUTINE DETME
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
      COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,DUM380
      COMMON /XS3/ ISAL,ISAR
      COMMON /PROF/ WSD,WSU,VHD,VHU,KD,KU,HF,HE,AU,ALFU,DIST,QBO,A2N,H1N
     1,TOL,QT,QAVG,TEDS
      COMMON /QR/ QRL,QRR
C-old COMMON /BP2/ M,IECC,E
      COMMON /BP2/ M,IECC,E,AJ,IFLOW,BRWID,A2FULL,AJF
C---end change
      COMMON /BP3/ IECCB4
      IKL=ISAL
      IKR=ISAR
      KL=0.0
      KR=0.0
      KQ=0.0
      IF (ISAL.EQ.99) IKL=0
      IF (ISAR.EQ.99) IKR=0
      IF (IKL.GE.1) CALL KSUM (1,IKL,KL)
      IF (IKR.GE.2) CALL KSUM (IKR,NSA,KR)
      IKQL=IKL+1
      IKQR=IKR-1
      IF (IKQR.LT.0) IKQR=NSA
      CALL KSUM (IKQL,IKQR,KQ)
      K1=KL+KQ+KR
      IF (QRL.LE.0.0) GO TO 10
      KL=KL-(QRL*K1/QT)
   10 IF (QRR.LE.0.0) GO TO 20
      KR=KR-(QRR*K1/QT)
   20 KB=KL+KQ+KR
      IF (KQ.LT.KB) GO TO 30
      M=1.00
      GO TO 40
   30 M=KQ/KB
   40 IF (KL.LT.0.0) KL=0.0
      IF (KR.LT.0.0) KR=0.0
      IF (KL.NE.0.0.OR.KR.NE.0.0) GO TO 50
      E=0.0
      IECC=0
      GO TO 70
   50 E=1.0-(AMIN1(KL,KR)/AMAX1(KL,KR))
      IECC=IFIX(20.0*E-15.0)
      IF (IECC.GT.0) GO TO 60
      GO TO 70
   60 IF (IECC.EQ.IECCB4) GO TO 70
      CALL SETKE (IECC)
   70 IECCB4=IECC
      RETURN
      END
      SUBROUTINE DIGCON (IR,K)
C-old DIMENSION K(3)
C-old INTEGER ALPHNO(11)/'1','2','3','4','5','6','7','8','9','0',' '/
      CHARACTER*1 ALPHNO(11), K(3)
      DATA ALPHNO/'1','2','3','4','5','6','7','8','9','0',' '/
C---end change
      DO 10 I=1,3
   10 K(I)=ALPHNO(11)
      IF (IR.LT.0) RETURN
      IONE=MOD(IR,10)
      ITEN=(MOD(IR,100)-IONE)/10
      IHUN=(IR-(10*ITEN+IONE))/100
      IF (IHUN.NE.0) K(1)=ALPHNO(IHUN)
      IF (ITEN.NE.0) K(2)=ALPHNO(ITEN)
      IF (IONE.NE.0) K(3)=ALPHNO(IONE)
      IF (IHUN.GT.0) GO TO 20
      GO TO 30
   20 IF (ITEN.EQ.0) K(2)=ALPHNO(10)
   30 IF (IONE.EQ.0) K(3)=ALPHNO(10)
      RETURN
      END
      SUBROUTINE DOALOT (VRSARG)
      INTEGER SKEW,PIER,ABUT,WW,SA,TSA(200)
C-old REAL N1,N3,SECID*8
      REAL N1,N3
      CHARACTER*8 SECID
C---end change
      COMMON /XSDATA/ S(200),SA(200),G(200),BL(20),AB(20),N1(20),N3(20)
      COMMON /IDAT/ IDATA(705)
      COMMON /RDATA/ RDEL(50),RDSTA(50),ISEG(50),IT(10),RDWID,NGRD
      COMMON /PDATA/ PIERW(25),PIEREL(25)
      COMMON /PIERA/ ELPR(25),APR(25),NPA
C-old COMMON /BP1/ SKEW,PIER,ABUT,WW,SUBEL,BELDUM
      COMMON /BP1/ SKEW,PIER,ABUT,WW,SUBEL,BELMX
C---end change
      COMMON /BP4/ RGLMN,RGRMN,QTOL,RDIST
      COMMON /BP6/ ISEGL,ISEGR,NSEG
C-old COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,CD3C80
      COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,DUM380
      CHARACTER*1 CD3C80
      COMMON /XS1C/ CD3C80
C---end change
      COMMON /JPTS/ JLT,JRT
      COMMON /XS3/ ISAL,ISAR
C-old COMMON /AV/ IR1VEC(3)               /******************************
C-old DIMENSION Q(20), TS(200), TG(200), IDATME(5),  IRAY(1)
      DIMENSION Q(20), TS(200), TG(200), IRAY(1)
      CHARACTER*14 IDATME
      COMMON /AV/ IR11,IR12,IR13
      SAVE IDATME, VRSION, IPAGE
C---end change
      DATA IPAGE/0/
      CALL DATME(IDATME)
      VRSION = VRSARG
      RETURN
      ENTRY DREAD(JDATA,IFILE,IREC,SECID,Q,*,*,*,*,*)
C-old    IR1VEC(IFILE-10) = IREC + 1                  /******************
         IF (IFILE.EQ.13) THEN
           IR13 = IREC + 1
         ELSEIF (IFILE.EQ.12) THEN
           IR12 = IREC + 1
         ELSEIF (IFILE.EQ.11) THEN
           IR11 = IREC + 1
         ENDIF
C---end change
      J=JDATA
      IF (J.LT.1.OR.J.GT.5) J=5
      GO TO (10,20,30,50,40), J
C-old   10 READ (IFILE'IREC) SECID,HSUBO,IDIST,ISAL,ISAR,NOPTS,(S(I),SA(I),G(
C-old1I),I=1,NOPTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),GMIN,GMAX,(Q(I
C-old2),I=1,20),CD3C80

   10 READ (IFILE,REC=IREC) SECID,HSUBO,IDIST,ISAL,ISAR,NOPTS,(S(I),
     1    SA(I),G(I),I=1,NOPTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),
     2    GMIN,GMAX,(Q(I),I=1,20),CD3C80
C---end change
      GO TO 55
C-old   20 READ (IFILE'IREC) SECID,HSUBO,IDIST,NOPTS,(S(I),SA(I),G(I),I=1,NOP
C-old1TS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),GMIN,GMAX,SUBEL,SKEW,ABU
C-old2T,WW,CD3C80
   20 READ (IFILE,REC=IREC) SECID,HSUBO,IDIST,NOPTS,(S(I),SA(I),G(I),
     1      I=1,NOPTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),GMIN,GMAX,
     2      SUBEL,SKEW,ABUT,WW,CD3C80
C---end change
      GO TO 55
C-old   30 READ (IFILE'IREC) NPA,(ELPR(I),APR(I),I=1,NPA),PIER
   30 READ (IFILE,REC=IREC) NPA,(ELPR(I),APR(I),I=1,NPA),PIER
C---end change
      GO TO 55
C-old   40 READ (IFILE'IREC) SECID,HSUBO,IDIST,ISAL,ISAR,NOPTS,(S(I),SA(I),G(
C-old1I),I=1,NOPTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),GMIN,GMAX,CD3C
C-old280
   40 READ (IFILE,REC=IREC) SECID,HSUBO,IDIST,ISAL,ISAR,NOPTS,(S(I),
     1      SA(I),G(I),I=1,NOPTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),
     2      GMIN,GMAX,CD3C80
C---end change
      GO TO 55
C-old   50 READ (IFILE'IREC) SECID,RDWID,ISEGL,ISEGR,NGRD,(RDSTA(I),ISEG(I),R
C-old1DEL(I),I=1,NGRD),NSEG,(IT(I),I=1,NSEG),QTOL,RGLMN,RGRMN
   50 READ (IFILE,REC=IREC) SECID,RDWID,ISEGL,ISEGR,NGRD,(RDSTA(I),
     1    ISEG(I),RDEL(I),I=1,NGRD),NSEG,(IT(I),I=1,NSEG),QTOL,RGLMN,
     2    RGRMN
C---end change
   55 RETURN J
      ENTRY DWRITE(JDATA,IFILE,IREC,SECID,Q,*)
C-old IR1VEC(IFILE-10) = IREC + 1                /********************
      IF (IFILE.EQ.13) THEN
        IR13 = IREC + 1
      ELSEIF (IFILE.EQ.12) THEN
        IR12 = IREC + 1
      ELSEIF (IFILE.EQ.11) THEN
        IR11 = IREC + 1
      ENDIF
C---end change
C
      J=JDATA
      IF (J.LT.1.OR.J.GT.5) J=5
      GO TO (60,70,80,100,90), J
C-old   60 WRITE (IFILE'IREC) SECID,HSUBO,IDIST,ISAL,ISAR,NOPTS,(S(I),SA(I),G
C-old1(I),I=1,NOPTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),GMIN,GMAX,(Q(
C-old2I),I=1,20),CD3C80
   60 WRITE (IFILE,REC=IREC) SECID,HSUBO,IDIST,ISAL,ISAR,NOPTS,(S(I),
     1   SA(I),G(I),I=1,NOPTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),
     2   GMIN,GMAX,(Q(I),I=1,20),CD3C80
C---end change
      RETURN 1
C-old   70 WRITE (IFILE'IREC) SECID,HSUBO,IDIST,NOPTS,(S(I),SA(I),G(I),I=1,NO
C-old1PTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),GMIN,GMAX,SUBEL,SKEW,AB
C-old2UT,WW,CD3C80
   70 WRITE (IFILE,REC=IREC) SECID,HSUBO,IDIST,NOPTS,(S(I),SA(I),G(I),
     1     I=1,NOPTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),GMIN,GMAX,
     2     SUBEL,SKEW,ABUT,WW,CD3C80
C---end change
      RETURN 1
C-old   80 WRITE (IFILE'IREC) NPA,(ELPR(I),APR(I),I=1,NPA),PIER
   80 WRITE (IFILE,REC=IREC) NPA,(ELPR(I),APR(I),I=1,NPA),PIER
C---end change
      RETURN 1
C-old   90 WRITE (IFILE'IREC) SECID,HSUBO,IDIST,ISAL,ISAR,NOPTS,(S(I),SA(I),G
C-old1(I),I=1,NOPTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),GMIN,GMAX,CD3
C-old2C80
   90 WRITE (IFILE,REC=IREC) SECID,HSUBO,IDIST,ISAL,ISAR,NOPTS,(S(I),
     1     SA(I),G(I),I=1,NOPTS),NSA,(BL(I),AB(I),N1(I),N3(I),I=1,NSA),
     2     GMIN,GMAX,CD3C80
C---end change
      RETURN 1
C-old  100 WRITE (IFILE'IREC) SECID,RDWID,ISEGL,ISEGR,NGRD,(RDSTA(I),ISEG(I),
C-old1RDEL(I),I=1,NGRD),NSEG,(IT(I),I=1,NSEG),QTOL,RGLMN,RGRMN
  100 WRITE (IFILE,REC=IREC) SECID,RDWID,ISEGL,ISEGR,NGRD,(RDSTA(I),
     1     ISEG(I),RDEL(I),I=1,NGRD),NSEG,(IT(I),I=1,NSEG),QTOL,RGLMN,
     2     RGRMN
C---end change
      RETURN 1
      ENTRY FLOTXS(I5BEG)
      IO=0
      I5END=I5BEG+599
      DO 110 ID=I5BEG,I5END,3
      IO=IO+1
      S(IO)=FLOAT(IDATA(ID))
      IF (S(IO).EQ.-999999.) GO TO 120
      SA(IO)=IDATA(ID+1)
  110 G(IO)=FLOAT(IDATA(ID+2))/10.0
  120 I6BEG=I5END+1
      I6END=I6BEG+79
      IO=0
      DO 130 ID=I6BEG,I6END,4
      IO=IO+1
      BL(IO)=FLOAT(IDATA(ID))
      IF (BL(IO).EQ.-999.) RETURN
      AB(IO)=FLOAT(IDATA(ID+1))
      N1(IO)=FLOAT(IDATA(ID+2))/1000.0
  130 N3(IO)=FLOAT(IDATA(ID+3))/1000.0
      RETURN
      ENTRY FLOTPR
      IO=0
      DO 140 ID=2,51,2
      IO=IO+1
      PIERW(IO)=FLOAT(IDATA(ID))
      IF (PIERW(IO).EQ.-999999.) RETURN
  140 PIEREL(IO)=FLOAT(IDATA(ID+1))/10.0
      RETURN
      ENTRY FLOTRD(I5BEG)
      IO=0
      I5END=I5BEG+149
      DO 150 ID=I5BEG,I5END,3
      IO=IO+1
      RDSTA(IO)=FLOAT(IDATA(ID))
      IF (RDSTA(IO).EQ.-999999.) RETURN
      ISEG(IO)=IDATA(ID+1)
  150 RDEL(IO)=FLOAT(IDATA(ID+2))/10.0
      RETURN
      ENTRY VHEAD
      IPAGE=IPAGE+1
      WRITE (6,280) VRSION,IPAGE,IDATME
      RETURN
      ENTRY ENDPTS(JL,JR,NPTS,IL,IR,IRAY)
      JL=0
      JR=0
      IEND=NPTS-1
      IF (IL.EQ.0.OR.IL.EQ.99) GO TO 170
      DO 160 I=1,IEND
      IF (JL.NE.0) GO TO 170
      IF (IRAY(I).EQ.IL.AND.IRAY(I+1).EQ.IL+1) JL=I+1
  160 CONTINUE
  170 IF (IR.EQ.0.OR.IR.EQ.99) GO TO 190
      DO 180 I=1,IEND
      IF (JR.NE.0) GO TO 190
      IF (IRAY(I).EQ.IR.AND.IRAY(I-1).EQ.IR-1) JR=I
  180 CONTINUE
  190 RETURN
      ENTRY PAREA
      NPA=1
      ELPR(1)=PIEREL(1)
      APR(1)=0.0
      DO 200 I=2,NOPTS
      IF (PIEREL(I).EQ.ELPR(NPA)) GO TO 200
      NPA=NPA+1
      APR(NPA)=APR(NPA-1)+(PIEREL(I)-PIEREL(I-1))*(PIERW(I)+PIERW(I-1))/
     12.0
      ELPR(NPA)=PIEREL(I)
  200 CONTINUE
      NPA=NPA+1
      ELPR(NPA)=ELPR(NPA-1)+1.0
      APR(NPA)=APR(NPA-1)
      RETURN
      ENTRY REVXS(STALT,START)
      JLT=0
      JRT=0
      INEW=1
      NEWPTS=NOPTS
      TS(1)=S(1)
      TG(1)=G(1)
      TSA(1)=SA(1)
      IF (STALT.LE.S(1)) JLT=1
      IF (START.GE.S(NOPTS)) JRT=205
      DO 260 IOLD=2,NOPTS
      INEW=INEW+1
      IF (JLT.NE.0) GO TO 220
      IF (STALT.NE.S(IOLD)) GO TO 210
      JLT=INEW
      GO TO 250
  210 IF (STALT.GT.S(IOLD)) GO TO 250
      TS(INEW)=STALT
      TG(INEW)=PROP(STALT,S,G,IOLD-1)
      JLT=INEW
      GO TO 240
  220 IF (JRT.NE.0) GO TO 250
      IF (START.NE.S(IOLD)) GO TO 230
      JRT=INEW
      GO TO 250
  230 IF (START.GT.S(IOLD)) GO TO 250
      TS(INEW)=START
      TG(INEW)=PROP(START,S,G,IOLD-1)
      JRT=INEW
  240 TSA(INEW)=SA(IOLD-1)
      INEW=INEW+1
      NEWPTS=NEWPTS+1
  250 TS(INEW)=S(IOLD)
      TG(INEW)=G(IOLD)
  260 TSA(INEW)=SA(IOLD)
      IF(JRT.GT.NEWPTS) JRT=NEWPTS
      NOPTS=NEWPTS
      DO 270 I=1,NOPTS
      S(I)=TS(I)
      G(I)=TG(I)
  270 SA(I)=TSA(I)
      RETURN
C-old  280 FORMAT ('1'//20X,'USGS COMPUTER PROGRAM E431 -- VERSION',F7.3,' **
C-old1* PAGE =',I4,'  RUN DATE=',5A3)
  280 FORMAT ('1'/18X,'*** WARNING-- OBSOLETE PROGRAM. ',
     $   '   FOR DOCUMENTATION OF PREVIOUS COMPUTATIONS ONLY. ***' 
     $   /20X,'USGS COMPUTER PROGRAM E431 -- VERSION', F7.3,
     $   ' *** PAGE =',I4,'  RUN DATE=',A)
C---end change
      END
      SUBROUTINE EDITCH (L1,L2)
C-old INTEGER CHAR(12)/' ','0','1','2','3','4','5','6','7','8','9','-'/,
C-old1NONO(4)/'M','B','I','U'/
C-old COMMON /INALF/ ICARD,INPUTA(80),IBAD(80),JCARD,LCARD,NOTBL,LINES
      CHARACTER*1 CHAR(12), NONO(4)
      CHARACTER*1 INPUTA, IBAD
      COMMON /INALFC/ INPUTA(80), IBAD(80)
      INTEGER ICARD, JCARD, LCARD, LINES
      LOGICAL NOTBL
      COMMON /INALF/ ICARD, JCARD, LCARD, LINES, NOTBL
C---end change
      DIMENSION IRAY(1)
C-new
      DATA CHAR/' ','0','1','2','3','4','5','6','7','8','9','-'/,
     1     NONO/'M','B','I','U'/
C---end change
      ICOL=1
      LCOL=L1
   10 DO 30 I=ICOL,LCOL
      DO 20 J=1,12
      IF (INPUTA(I).EQ.CHAR(J)) GO TO 30
   20 CONTINUE
      IBAD(I)=NONO(3)
   30 CONTINUE
      IF (LCOL.GE.72) RETURN
      ICOL=L2
      LCOL=72
      GO TO 10
      ENTRY EDITBJ(IRAY,LKOL,*)
      I=1
   40 I=I+1
      IF (I.GT.IRAY(1)+1) GO TO 80
      IB=IRAY(I)
      IF (IB.LT.0) GO TO 50
      IF (INPUTA(IB).NE.CHAR(1)) IBAD(IB)=NONO(2)
      IF (INPUTA(IB-1).EQ.CHAR(1)) IBAD(IB-1)=NONO(1)
      GO TO 40
   50 IB=-IB
      IE=IRAY(I+1)
      INC=IRAY(I+2)
      I=I+2
      DO 70 IK=IB,IE,INC
      IF (INPUTA(IK).NE.CHAR(1)) IBAD(IK)=NONO(2)
      IF (INC.EQ.1) GO TO 70
      IF (I.EQ.4.AND.IB.EQ.19) GO TO 60
      IF (INPUTA(IK-1).EQ.CHAR(1)) IBAD(IK-1)=NONO(1)
      GO TO 70
   60 IF (INPUTA(IK-1).NE.CHAR(1)) IBAD(IK-1)=NONO(2)
      IF (INPUTA(IK-2).NE.CHAR(1)) IBAD(IK-2)=NONO(2)
   70 CONTINUE
      GO TO 40
   80 IF (IRAY(1).LE.3) RETURN
      GO TO (90,120,100,120,110,120), ICARD
   90 IBAD(48)=CHAR(1)
      IBAD(57)=CHAR(1)
      GO TO 120
  100 IBAD(13)=CHAR(1)
      GO TO 120
  110 IF (INPUTA(80).EQ.CHAR(1)) IBAD(80)=NONO(1)
  120 IF (LKOL.GE.72) GO TO 150
      LCOLP1=LKOL+1
      DO 140 I=LCOLP1,80
      IF (INPUTA(I).EQ.CHAR(1)) GO TO 130
      IBAD(I)=NONO(4)
      GO TO 140
  130 IBAD(I)=CHAR(1)
  140 CONTINUE
  150 IF (IBAD(2).EQ.NONO(3)) IBAD(2)=NONO(2)
      IF (IBAD(8).EQ.NONO(3)) IBAD(8)=NONO(2)
      IF (INPUTA(15).EQ.CHAR(6).AND.ICARD.EQ.3) RETURN
      ENTRY EDITSP (  LKOL ,*)
      DO 160 I=1,80
      IF (IBAD(I).NE.CHAR(1)) GO TO 170
  160 CONTINUE
      RETURN
  170 WRITE (6,200) IBAD
      NOTBL=.TRUE.
      LINES=LINES+1
      DO 180 I=1,LKOL
      IF (IBAD(I).EQ.NONO(3)) RETURN 1
  180 CONTINUE
      RETURN
      ENTRY SEQCHK(LSEQ,ISEQ)
      IF (ISEQ.GT.LSEQ) GO TO 190
      WRITE (6,210)
      LINES = LINES +1
  190 LSEQ=ISEQ
      RETURN
  200 FORMAT (' ',80A1,24X,'**ERROR(S)**')
  210 FORMAT (' **SEQUENCE**')
      END
      SUBROUTINE ERRMSG (ISEV,VAR1,IR1,PROB1,PROB2,VAR2,IR2,IV1,AVAL)
      LOGICAL ABORTX,ERRHD,FLUSH,ABORTP
C-old REAL*8 SEVERE(2)/'WARNING ','ABORTIVE'/,VAR1,PROB1,PROB2,VAR2,AVAL
C-old1,SECID
      CHARACTER*8 SEVERE(2),VAR1,PROB1,PROB2,VAR2,AVAL,SECID
C---end change
      COMMON /ABX/ ABORTX
      COMMON /IDSEC/ SECID
C-new
      CHARACTER*4 STRID, GSID, FWID
C---end change
      COMMON /ID/ STRID(10),GSID(2),FWID(5)
C-old DIMENSION IR1A(3), IR2A(3), IV1A(3)
      CHARACTER*1 IR1A(3), IR2A(3), IV1A(3)
      SAVE ERRHD, LINES, IPAGE
      DATA SEVERE/'WARNING ','ABORTIVE'/, ERRHD/.FALSE./,IPAGE/0/,
     1     LINES/0/
C---end change
      CALL DIGCON (IR1,IR1A)
      CALL DIGCON (IR2,IR2A)
      CALL DIGCON (IV1,IV1A)
      IF (ERRHD.AND.LINES.LT.55) GO TO 10
      LINES=10
      IPAGE=IPAGE+1
      CALL VHEAD
      WRITE (6,20) IPAGE,STRID,GSID
      ERRHD=.TRUE.
   10 LINES=LINES+1
      WRITE (6,30) SECID,SEVERE(ISEV),VAR1,IR1A,PROB1,PROB2,VAR2,IR2A,
     1IV1A,AVAL
      IF (ISEV.EQ.1) RETURN
      IF (ABORTX) RETURN
      ABORTX=.TRUE.
      RETURN
      ENTRY INITEM
      ERRHD=.FALSE.
      IPAGE=0
      LINES=0
      RETURN
      ENTRY SETNXS(IOUT,NXSPRO,ABORTP,FLUSH)
      IF (ABORTP) RETURN
      NXSPRO=IOUT
      FLUSH=.TRUE.
      ABORTP=.TRUE.
      RETURN
C
   20 FORMAT (//20X,'PAGE',I3,' OF EDITING NOTES FOR: ',10A4,1X,2A4//27X
     1,'ERROR     FIRST  ',26X,'SECOND',9X,'VALUE'/20X,'SECID  SEVERITY
     2 VARIABLE  NO.  ERROR MESSAGE     VARIABLE  NO.  ASSUMED'/)
   30 FORMAT (20X,A5,2X,A8,2X,A8,2X,3A1,2X,2A8,2X,A8,2(2X,3A1),A8)
      END
      SUBROUTINE ERRQ (QERR,IFLOW)
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
      COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,DUM380
      COMMON /SUBM/ YUOVRZ(12),CDARAY(12),BEDEL,Z,ANET
      COMMON /QR/ QRL,QRR
Cunused COMMON /BP4/ RGLMN,RGRMN,QTOL,RDIST
      COMMON /BP5/ KSTAR
      COMMON /PROF/ WSD,WSU,VHD,VHU,KD,KU,HF,HE,AU,ALFU,DIST,QBO,A2N,H1N
     1,TOL,QT,QAVG,TEDS
      CALL XSPROP (1,NOPTS,WSU,AU,KU,ALFU)
      CALL ROADQ
      ENTRY ERRQBO(QERR,IFLOW)
      QBO=0.0
      GO TO (10,20,30), IFLOW
   10 HSUBB=WSU+VHU-TEDS
      IF (HSUBB.LE.0.0) HSUBB=0.000001
      CALL BWCOEF
      QBO=8.02*A2N*SQRT(HSUBB/KSTAR)
      GO TO 40
   20 YU=WSU-BEDEL
      IF (YU-Z/2.0+VHU.LT.0.0) GO TO 40
      CD=TERPL8(YU/Z,1,11,YUOVRZ,CDARAY)
      QBO=8.02*CD*ANET*SQRT(YU-Z/2.0+VHU)
      GO TO 40
   30 IF (WSU+VHU-WSD.LT.0.0) GO TO 40
      QBO=6.42*ANET*SQRT(WSU+VHU-WSD)
   40 QERR=QRR+QRL+QBO-QT
      RETURN
      END
      SUBROUTINE GET123 (*)
C-old COMMON /INALF/ ICARD,INPUTA(80),IBAD(80),JCARD,LCARD,NOTBL,LINES
      CHARACTER*1 INPUTA, IBAD
      COMMON /INALFC/ INPUTA(80), IBAD(80)
      INTEGER ICARD, JCARD, LCARD, LINES
      LOGICAL NOTBL
      COMMON /INALF/ ICARD, JCARD, LCARD, LINES, NOTBL
C---end change
      ICARD=1
      IF (JCARD.EQ.7) WRITE (6,50) INPUTA
   10 WRITE (6,40)
      CALL ALPHIN (*20,*30,*20)
      RETURN
   20 IF (JCARD.EQ.2.OR.JCARD.EQ.3) RETURN
      IF (JCARD.EQ.7) WRITE (6,50) INPUTA
      GO TO 10
   30 RETURN 1
   40 FORMAT ('+',104X,'**NO EDIT**')
   50 FORMAT (' ',80A1)
      END
C-old REAL FUNCTIONKSUBB(ARGM)
      REAL FUNCTION KSUBB(ARGM)
C---end change
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
      COMMON /MCURV/ MKB(11),MJ(6),MSIG(7),MKE(5),MKS(8)
      COMMON /KCURV/ KBARAY(11),DKARAY(6),SGARAY(7),KSARAY(8),KSUBEL(5),
     1KSUBEH(5)
      KSUBB=TERPL8(ARGM,1,10,MKB,KBARAY)
      RETURN
      ENTRY KSUBP(ARGJ,ARGM)
      KSUBP=TERPL8(ARGJ,1,5,MJ,DKARAY)*TERPL8(ARGM,1,6,MSIG,SGARAY)
      RETURN
      ENTRY KSUBS(ARGM)
      KSUBS=TERPL8(ARGM,1,7,MKS,KSARAY)
      RETURN
      ENTRY KSUBE(ARGM,ARGE,IARG)
      KLO=TERPL8(ARGM,1,4,MKE,KSUBEL)
      KHI=TERPL8(ARGM,1,4,MKE,KSUBEH)
      KSUBE=KLO+(20.0*ARGE-(IARG+15))*(KHI-KLO)
      RETURN
      END
      SUBROUTINE OUTPUT (NJREC)
C-old REAL*8 SECID
      CHARACTER*8 SECID
C---end change
      LOGICAL LOGCL
      COMMON /AV/ IR11,IR12,IR13
      DIMENSION ODATA(14)
      IPREV=0
      IPAGE=0
      LINES=3*NJREC
      LPAGE=LINES/45
      IF (MOD(LINES,45).GT.0) LPAGE=LPAGE+1
      CALL HEAD (IPAGE,LPAGE)
C-old READ (13'IR13) SECID,IDIST,(ODATA(I),I=1,11)
C-old IR13 = IR13 + 1                          /************************
      READ (13,REC=IR13) SECID,IDIST,(ODATA(I),I=1,11)
      IR13 = IR13 + 1
C---end change
      QPREV=ODATA(1)
      WRITE (6,120) SECID,IDIST,(ODATA(I),I=1,11)
      IF (IR13.GT.NJREC) GO TO 100
C-old  10 READ (13'IR13) LOGCL,IDATA,SECID,IDIST,LDIST,(ODATA(I),I=1,14)
C-old IR13 = IR13 + 1                                    /*******************
   10 READ (13,REC=IR13) LOGCL,IDATA,SECID,IDIST,LDIST,(ODATA(I),I=1,14)
      IR13 = IR13 + 1
C---end change
      IF (IDATA.EQ.2) GO TO 30
      IF (IPREV.EQ.5) GO TO 20
      WRITE (6,130)
   20 WRITE (6,140) SECID,IDIST,LDIST,(ODATA(I),I=1,14)
      IF (IR13.GT.NJREC) GO TO 100
      IPREV=0
      QPREV=ODATA(1)
      IF (IR13.LE.IPAGE*15) GO TO 10
      WRITE (6,130)
      CALL HEAD (IPAGE,LPAGE)
      IPREV=5
      GO TO 10
   30 WRITE (6,150)
      WRITE (6,160) SECID,IDIST,(ODATA(I),I=1,12)
      WRITE (6,130)
      IF (IR13.LE.IPAGE*15) GO TO 40
      CALL HEAD (IPAGE,LPAGE)
   40 IF (LOGCL) GO TO 50
      IF (ODATA(1).LT.QPREV) GO TO 60
      WRITE (6,170)
      GO TO 70
   50 WRITE (6,180)
      GO TO 70
C-old   60 READ (13'IR13) QRL,QRR
C-old IR13 = IR13 + 1                               /**********************
   60 READ (13,REC=IR13) QRL,QRR
      IR13 = IR13 + 1
C---end change
      WRITE (6,190) QRL,QRR
      IR13=IR13-1
   70 IR13=IR13+1
      WRITE (6,200)
      WRITE (6,130)
      IF (IR13.LE.IPAGE*15) GO TO 80
      CALL HEAD (IPAGE,LPAGE)
C-old   80 READ (13'IR13) LOGCL,IDATA,SECID,IDIST,LDIST,(ODATA(I),I=1,14)
C-old IR13 = IR13 + 1                                   /***********************
   80 READ (13,REC=IR13) LOGCL,IDATA,SECID,IDIST,LDIST,(ODATA(I),I=1,14)
      IR13 = IR13 + 1
C---end change
      WRITE (6,210) SECID,IDIST,LDIST,(ODATA(I),I=1,14)
      WRITE (6,130)
      IF (IR13.LE.IPAGE*15) GO TO 90
      CALL HEAD (IPAGE,LPAGE)
C-old   90 READ (13'IR13) (ODATA(I),I=1,13)
C-old IR13 = IR13 + 1                            /**************************
   90 READ (13,REC=IR13) (ODATA(I),I=1,13)
      IR13 = IR13 + 1
C---end change
      ODATA(1)=1.000-ODATA(1)
      ODATA(2)=1.000-ODATA(2)
      WRITE (6,220) (ODATA(I),I=1,13)
      IPREV=5
      WRITE (6,230)
      IF (IR13.GT.NJREC) GO TO 110
      IF (IR13.LE.IPAGE*15) GO TO 10
      CALL HEAD (IPAGE,LPAGE)
      IPREV=5
      GO TO 10
  100 WRITE (6,130)
  110 WRITE (6,240)
      RETURN
  120 FORMAT (20X,A5,' AT',I8,' /',5X,'0 /',F8.0,' /',F7.0,' /',F9.0,' /
     1',F5.2,2(' /',F6.0)/21X,F8.2,' /',F7.2,' /',17X,'/',F8.2,2(' /',F7
     2.2),'/',9X,'*IS*')
  130 FORMAT (20X,79('-'))
  140 FORMAT (20X,A5,' AT',I8,' /',I6,' /',F8.0,' /',F7.0,' /',F9.0,' /'
     1,F5.2,2(' /',F6.0)/21X,F8.2,' /',3(F7.2,' /'),F8.2,2(' /',F7.2),'
     2/',F7.3,'  *XS*')
  150 FORMAT (20X,28('='),' BEGIN BRIDGE ANALYSIS ',28('='))
  160 FORMAT (20X,A5,' AT',I8,' /',7X,'/',F8.0,' /',F7.0,' /',F9.0,' /',
     1F5.2,2(' /',F6.0)/21X,F8.2,' /',F7.2,' /',7X,'...',F2.0,'..  (',F5
     2.3,')   ',2(' /',F7.2),' /',9X,'*BO*')
  170 FORMAT (21X,'NO ROAD OVERFLOW')
  180 FORMAT (21X,'NO ROAD-GRADE DATA')
  190 FORMAT (21X,'ROAD OVERFLOW (CFS) / LEFT ',F8.0,' / RIGHT ',F8.0,'
     1/')
  200 FORMAT ('+',94X,'*RG*')
  210 FORMAT (20X,A5,' AT',I8,' /',I6,' /',F8.0,' /',F7.0,' /',F9.0,' /'
     1,F5.2,2(' /',F6.0)/21X,F8.2,' /',3(F7.2,' /'),F8.2,2(' /',F7.2),'
     2/',F7.3,'  *AS*')
  220 FORMAT (23X,'M = ',F4.2,' / E = ',F4.2,' / K* = ',F4.2,' /',F7.0,'
     1 /',F9.0,' /',F5.2,2(' /',F6.0)/21X,F8.2,' /',F7.2,' /',17X,'/',F8
     2.2,2(' /',F7.2),' /',9X,'*AS*')
  230 FORMAT (20X,29('='),' END BRIDGE ANALYSIS ',29('='))
  240 FORMAT ('0',49X,'END OF THIS PROFILE')
      END
      SUBROUTINE PRMSG (IP1,IP2,IN1ARG,VAR1,VAR2,IS1,IS2)
C-old REAL*8 SECID
      CHARACTER*8 SECID
C---end change
      LOGICAL ERRHD
C-old REAL PROB(77)/
      CHARACTER*4 PROB(77), SOLU(56), VNAM(4), AFLOW(4), PFLOW
      COMMON /IDSEC/ SECID
      CHARACTER*4 STRID, GSID, FWID
      COMMON /ID/ STRID(10),GSID(2),FWID(5)
      SAVE ERRHD, LINES, Q, WS, IPAGE
C---end change
      DATA PROB/
     1'INIT','IAL ','WS T','OO L','OW  ','TOL ','FAIL','URE ','BETW',
     2'EEN ','WS N','OT F','OUND',' BET','WEEN','TEN ','FRDN',' FAI',
     3'LURE','S   ','LEFT',' BAN','K EX','TEND','ED  ','RIGH','T BA',
     4'NK E','XTEN','DED ','KU/K','D < ','0.7 ','OR >',' 1.4','H1N ',
     5'TOO ','LOW ','J EX','CEED','S RA','NGE ','QRD ','> QT','MIN ',
     6'QBO ','> QT','MAX ','QBO ','< QT','QTOL',' FAI','LURE','MAX ',
     7'QTC ','< QT','MIN ','QTC ','> QT','ROAD',' NOT',' COD','ED  ',
     8'WSU ','> BE','LMX ','(1) ','YU/Z',' < 1','.1 (','1)  ','FLOO',
     9'DWAY',' DAT','A FL','USHE','D   '/
C-old REAL SOLU(56)/
      DATA SOLU/
     1'ABOR','TED ','PROF','ILE ','USED',' COM','PUTE','D WS','U   ',
     2'USED',' HIG','HER ','WS  ','USED',' DEL',' = 0','.25 ','    ',
     3'USED',' LOW','ER W','S   ','ASSU','MED ','H1N=','WSD+','0.01',
     4'USED',' J L','IMIT','ASSU','MED ','WSU ','= H1','N   ','ASSU',
     5'MED ','WSU ','= BE','LMX ','ASSU','MED ','WSU ','= GM','AX  ',
     6'CHEC','KED ','QBO ','(2) ','ASSU','MED ','QBO ','(1) ','CHEC',
     7'KED ','QRD '/
C-old REAL VNAM(4)/'WS =','FN =','LO =','HI ='/
C-old REAL AFLOW(4)/' (1)',' (2)',' (3)','    '/
C-old COMMON /IDSEC/ SECID
C-old COMMON /ID/ STRID(10),GSID(2),FWID(5)
      DATA VNAM/'WS =','FN =','LO =','HI ='/, Q/0.0/, WS/0.0/,LINES/0/,
     1     AFLOW/' (1)',' (2)',' (3)','    '/, ERRHD/.FALSE./,IPAGE/0/,
     2     PFLOW/'    '/
C---end change
      IN1 = IN1ARG
   10 IF (ERRHD.AND.LINES.LT.55) GO TO 20
      LINES=10
      IPAGE=IPAGE+1
      CALL VHEAD
      WRITE (6,40) IPAGE,STRID,GSID,Q,WS
      ERRHD=.TRUE.
   20 WRITE (6,50) SECID,(PROB(I),I=IP1,IP2),PFLOW
      IF (IN1.LE.0) GO TO 30
      WRITE (6,60) VNAM(IN1),VAR1,VNAM(IN1+1),VAR2
   30 WRITE (6,70) (SOLU(I),I=IS1,IS2)
      LINES=LINES+1
      IF(PFLOW.NE.AFLOW(4)) PFLOW=AFLOW(4)
      RETURN
      ENTRY INITPM(WAGM,QAGM)
      WS = WAGM
      Q  = QAGM
      ERRHD=.FALSE.
      PFLOW=AFLOW(4)
      IPAGE=0
      LINES=0
      RETURN
      ENTRY PRMSGA(IP1,IP2,IS1,IS2,IFLO)
      PFLOW=AFLOW(IFLO)
      ENTRY PRMSGZ(IP1,IP2,IS1,IS2)
      IN1=0
      GO TO 10
   40 FORMAT (//20X,'PAGE',I3,' OF PROFILE NOTES FOR: ',10A4,1X,2A4/25X,
     1'INITIAL VALUES ARE:  Q =',F8.0,'  H =',F8.2//20X,'SECID,ERROR OR
     2WARNING MESSAGE,INTERMEDIATE RESULTS(IF ANY),ACTION TAKEN'/)
   50 FORMAT (20X,A5,',',6A4)
   60 FORMAT ('+',49X,',',2(A4,F8.2,4X))
   70 FORMAT ('+',78X,',',5A4)
      END
      SUBROUTINE PROCAL (IQ,NXSPRO,FLUSH,SURCH,DELH,TOLL,FN)
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
C-old REAL*8 SECID,BRID,RDID,N1*4,N3*4
      CHARACTER SECID*8,BRID*8,RDID*8
      REAL N1, N3
C---end change
      LOGICAL NEW,NOROAD,NOKP,NOKS,LOGDUM,USEMEM,FLDWAY,FLUSH
      LOGICAL XTENDL,XTENDR
      INTEGER SA,SKEW,WW,ABUT,DATA,PIER
      COMMON /NRAYS/ NSEQ3(99),NDATA(99),NFILE(99),NREC(99)
      COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,DUM380
      COMMON /BP1/ SKEW,PIER,ABUT,WW,SUBEL,BELMX
      COMMON /XTEND/ XTENDL,XTENDR
      COMMON /BP2/ M,IECC,E,AJ,IFLOW,BRWID,A2FULL,AJF
      COMMON /BP4/ RGLMN,RGRMN,QTOL,RDIST
      COMMON /BP5/ KSTAR
Cunused COMMON /BP6/ ISEGL,ISEGR,NSEG
      COMMON /PROF/ WSD,WSU,VHD,VHU,KD,KU,HF,HE,AU,ALFU,DIST,QBO,A2N,H1N
     1,TOL,QT,QAVG,TEDS
      COMMON /QR/ QRL,QRR
Cunused COMMON /XS3/ ISAL,ISAR
      COMMON /LOGIG/ NOROAD,NOKP,NOKS
      COMMON /INTS/ SINTL,SINTR
      COMMON /AV/ IR11,IR12,IR13
      COMMON /XSDATA/ S(200),SA(200),G(200),BL(20),AB(20),N1(20),N3(20)
      COMMON /RDATA/ RDEL(50),RDSTA(50),ISEG(50),IT(10),RDWID,NGRD
      COMMON /FLAG/ DATA
      COMMON /IWS/ WSI(20)
C-old COMMON /PARM/ INX,INQ,ITOL,IDELH,IFN
Cunused COMMON /PARM/ INX,INQ,ITOL,IDELH,IFN,NOQ,NXS
C---end change
      COMMON /IDSEC/ SECID
      COMMON /SAV/ SAVEL(99),USEMEM
      COMMON /FW/ FLDWAY
      DIMENSION Q(20), GRBG(7)
      DATA GRBG/7*0.0/
      LOGDUM=.TRUE.
      TOL=TOLL
      IR13=1
      JREC=0
      NEW=.TRUE.
      IZERO=0
      NOXS=0
   10 NOKP=.TRUE.
      NOKS=.FALSE.
      NOROAD=.TRUE.
   20 NROOTS=0
   30 NOXS=NOXS+1
      IF (NDATA(NOXS).NE.9) GO TO 40
      IF (NOXS.EQ.NXSPRO) RETURN
      GO TO 30
   40 IF (FLDWAY.AND.USEMEM.AND.SAVEL(NOXS).EQ.11000.) RETURN
      DATA=NDATA(NOXS)
      IREC=NREC(NOXS)
      IF (NFILE(NOXS).EQ.11) GO TO 50
      JREC=JREC+1
      IREC=JREC
   50 CALL DREAD (DATA,NFILE(NOXS),IREC,SECID,Q,*60,*100,*120,*130,*140)
   60 QU=Q(IQ)
      IF (.NOT.NEW) GO TO 140
      NEW=.FALSE.
      WSD=WSI(IQ)
      CALL INITPM (WSD,QU)
      IF (.NOT.FLDWAY) GO TO 70
      WSD=WSD+SURCH
      IF (.NOT.FLUSH) GO TO 70
      CALL PRMSGZ (72,77,1,4)
C*PN-34* FLOODWAY DATA FLUSHED ** ABORTED PROFILE
      RETURN
   70 IF (WSD.GT.GMIN) GO TO 80
      CALL PRMSGZ (1,5,1,4)
C*PN- 1* INITIAL WS TOO LOW   ** ABORTED PROFILE
      RETURN
   80 IF (.NOT.FLDWAY) SAVEL(NOXS)=WSD
      CALL XSPROP (1,NOPTS,WSD,SUMA,KD,ALPHA)
      V=QU/SUMA
      VHD=ALPHA*V**2/64.3
      QD=QU
      EG=WSD+VHD
      DISTD=IDIST
      CALL SAKAB (KSAMX,ASAMX,BSAMX)
      FRDN=QU*KSAMX/(KD*ASAMX*SQRT(32.2*ASAMX/BSAMX))
      IF (FLDWAY) GO TO 90
      IF (XTENDL) CALL PRMSGZ (21,25,5,9)
C*PN- 8* LEFT BANK EXTENDED   ** USED COMPUTED WSU
      IF (XTENDR) CALL PRMSGZ (26,30,5,9)
C*PN- 9* RIGHT BANK EXTENDED  ** USED COMPUTED WSU
C-old   90 WRITE (13'IR13) SECID,IDIST,QD,SUMA,KD,ALPHA,SINTL,SINTR,WSD,VHD,E
C-old1G,V,FRDN
C-old IR13 = IR13 + 1                     /**************
   90 WRITE (13,REC=IR13) SECID,IDIST,QD,SUMA,KD,ALPHA,SINTL,SINTR,WSD,
     1     VHD,EG,V,FRDN
      IR13 = IR13 + 1
C---end change
      GO TO 30
  100 BRID=SECID
      IBDIST=IDIST
      CALL XSPROP (1,NOPTS,WSD,SUMA,K2N,ALPH2)
      A2N=SUMA*COS(FLOAT(SKEW)/57.29578)
      SBOL=SINTL
      SBOR=SINTR
      BOB=(SBOR-SBOL)*COS(FLOAT(SKEW)/57.29578)
      SMIN=THEMIN(2,NOPTS,S)
      SMAX=THEMAX(NOPTS,S)
      BRWID=(SMAX-SMIN)*COS(FLOAT(SKEW)/57.29578)
      BELMX=GMAX
      IF (WSD.GT.(GMIN+0.80*(GMAX-GMIN)).AND.BOB.LT.(0.75*BRWID)) BOB=BR
     1WID
      IF (SUBEL.EQ.0.0) GO TO 110
      CALL XSPROP (1,NOPTS,BELMX,SUMA,K2FULL,ALPH2F)
      A2FULL=SUMA*COS(FLOAT(SKEW)/57.29578)
      SBORF=SINTR
      SBOLF=SINTL
  110 IF (.NOT.FLDWAY) SAVEL(NOXS)=WSD
      GO TO 30
  120 NOKP=.FALSE.
      IF (.NOT.FLDWAY) SAVEL(NOXS)=0.0
      GO TO 30
  130 NOROAD=.FALSE.
      IF (.NOT.FLDWAY) SAVEL(NOXS)=0.0
      RDID=SECID
      GO TO 30
  140 DISTU=IDIST
      DIST=DISTU-DISTD
      LDIST=DIST
      QAVG=(QU+QD)/2.0
      QT=QU
      DEL=0.5
      XOIN=WSD-0.5*DELH
      IF (XOIN.LT.HSUBO) XOIN=HSUBO
      IF (XOIN.LT.GMIN) XOIN=GMIN+0.5*DELH
      XMIN=XOIN
  150 XO=XOIN
  160 X=XO
      ITER=1
      CALL FOFX (X,FX)
      FXO=FX
      IF (ABS(FXO).GT.TOL) GO TO 180
  170 WSU=X
      CALL SAKAB (KSAMX,ASAMX,BSAMX)
      GO TO 270
  180 NOI=(GMAX-XO)/(DEL*DELH)
      DO 190 I=1,NOI
      X=XO+DEL*DELH
      XLO=XO
      XHI=X
      CALL FOFX (X,FX)
      IF (ABS(FX).LE.TOL) GO TO 170
      IF (FXO*FX.LT.0.0) GO TO 210
      XO=X
  190 FXO=FX
      IF (NROOTS.EQ.0) GO TO 240
  200 CALL PRMSGZ (11,13,1,4)
C*PN- 5* WS NOT FOUND         ** ABORTED PROFILE
      RETURN
  210 X1=X
      FX1=FX
  220 X=XO+(X1-XO)*FXO/(FXO-FX1)
      CALL FOFX (X,FX)
      IF (ABS(FX).LE.TOL) GO TO 170
      IF (ITER.GT.10) GO TO 230
      ITER=ITER+1
      IF (FX*FXO.LT.0.0) GO TO 210
      XO=X
      FXO=FX
      GO TO 220
  230 CALL PRMSG (6,10,3,XLO,XHI,10,13)
C*PN- 2* TOL FAILURE BETWEEN  ** USED HIGHER WS
      XO=XHI
      GO TO 160
  240 IF (XOIN.LE.GMIN+0.5*DELH.AND.DEL.EQ.0.25) GO TO 200
      IF (DEL.EQ.0.25) GO TO 250
      DEL=0.25
      IS=14
      GO TO 260
  250 XOIN=GMIN+0.5*DELH
      IS=19
  260 CALL PRMSG (11,15,3,XMIN,GMAX,IS,IS+3)
C*PN- 3* WS NOT FOUND BETWEEN ** USED DEL = 0.25           (IS=14)
C*PN- 4* WS NOT FOUND BETWEEN ** USED LOWER WS             (IS=19)
      GO TO 150
  270 FRDN=QU*KSAMX/(KU*ASAMX*SQRT(32.2*ASAMX/BSAMX))
      IF (FRDN.LT.FN) GO TO 290
      NROOTS=NROOTS+1
      IF (ABS(X-XOIN).GT.TOL) GO TO 280
      X=XOIN+DEL*DELH
      CALL FOFX (X,FX)
  280 XO=X
      FXO=FX
      ITER=1
      XOIN=XO
      CALL PRMSG (17,19,1,WSU,FRDN,10,13)
C*PN- 6* FRDN FAILURE         ** USED HIGHER WS
      IF (NROOTS.LT.10) GO TO 180
      CALL PRMSGZ (16,20,1,4)
C*PN- 7* TEN FRDN FAILURES    ** ABORTED PROFILE
      RETURN
  290 V=QU/AU
      EG=WSU+VHU
      IF (DATA.NE.5) GO TO 300
      IR13=IR13+2
      IF (WSU.GT.WSD) GO TO 300
      CALL PRMSGZ (36,38,23,27)
C*PN-11* H1N TOO LOW          ** ASSUMED H1N=WSD+0.01
      WSU=WSD+0.01
      CALL XSPROP (1,NOPTS,WSU,AU,KU,ALFU)
      HF=DIST*QAVG**2/(KD*KU)
      V=QU/AU
      VHU=ALFU*V**2/64.3
      EG=WSU+VHU
      FX=-0.011
      HE=WSU+VHU-FX-HF-WSD-VHD
      CALL SAKAB (KSAMX,ASAMX,BSAMX)
      FRDN=QU*KSAMX/(KU*ASAMX*SQRT(32.2*ASAMX/BSAMX))
  300 IF (FLDWAY) GO TO 310
      IF (XTENDL) CALL PRMSGZ (21,25,5,9)
C*PN- 8* LEFT BANK EXTENDED   ** USED COMPUTED WSU
      IF (XTENDR) CALL PRMSGZ (26,30,5,9)
C*PN- 9* RIGHT BANK EXTENDED  ** USED COMPUTED WSU
  310 IF (KU/KD.GE.0.7.AND.KU/KD.LE.1.4) GO TO 320
      CALL PRMSGZ (31,35,5,9)
C*PN-10* KU/KD < 0.7 OR > 1.4 ** USED COMPUTED WSU
C-old  320 WRITE (13'IR13) LOGDUM,DATA,SECID,IDIST,LDIST,QU,AU,KU,ALFU,SINTL,
C-old1SINTR,WSU,VHU,HF,HE,EG,V,FRDN,FX
C-old   IR13 = IR13 + 1                   /******************
  320 WRITE (13,REC=IR13) LOGDUM,DATA,SECID,IDIST,LDIST,QU,AU,KU,ALFU,
     1     SINTL,SINTR,WSU,VHU,HF,HE,EG,V,FRDN,FX
        IR13 = IR13 + 1
C---end change
      IF (DATA.NE.5) GO TO 360
      RDIST=DIST-RDWID
      H1N=WSU
      TEDS=WSD+VHD+HE+HF
      QT=QU
      CALL BRIDGE
      IR13=IR13-3
      WSB=WSD
      FLOW=IFLOW
      IF (IFLOW.EQ.1) GO TO 330
      WSB=BELMX
      A2N=A2FULL
      K2N=K2FULL
      SBOL=SBOLF
      SBOR=SBORF
      ALPH2=ALPH2F
      BOB=BRWID
      AJ=AJF
  330 V=QBO/A2N
      VH2=V**2/64.3
      DATA=2
      IF (WSB.GT.BELMX) WSB=BELMX
      FRDN=QBO/(A2N*SQRT(32.2*A2N/BOB))
C-old WRITE (13'IR13) NOROAD,DATA,BRID,IBDIST,IZERO,QBO,A2N,K2N,ALPH2,SB
C-old1OL,SBOR,WSB,VH2,FLOW,AJ,V,FRDN,(GRBG(I),I=1,2)
C-old   IR13 = IR13 + 1                 /**************************
      WRITE (13,REC=IR13) NOROAD,DATA,BRID,IBDIST,IZERO,QBO,A2N,K2N,
     1     ALPH2,SBOL,SBOR,WSB,VH2,FLOW,AJ,V,FRDN,(GRBG(I),I=1,2)
        IR13 = IR13 + 1
C---end change
      IF (NOROAD.OR.QRL.EQ.0.0.AND.QRR.EQ.0.0) GO TO 340
C-old WRITE (13'IR13) QRL,QRR
C-old   IR13 = IR13 + 1               /**********************
      WRITE (13,REC=IR13) QRL,QRR
        IR13 = IR13 + 1
C---end change
      IR13=IR13-1
  340 DATA=5
      IR13=IR13+2
      V=QT/AU
      EG=WSU+VHU
      CALL SAKAB (KSAMX,ASAMX,BSAMX)
      FRDN=QU*KSAMX/(KU*ASAMX*SQRT(32.2*ASAMX/BSAMX))
      IF (FLDWAY) GO TO 350
      IF (XTENDL) CALL PRMSGZ (21,25,5,9)
C*PN- 8* LEFT BANK EXTENDED   ** USED COMPUTED WSU
      IF (XTENDR) CALL PRMSGZ (26,30,5,9)
C*PN- 9* RIGHT BANK EXTENDED  ** USED COMPUTED WSU
C-old  350 WRITE (13'IR13) M,E,KSTAR,AU,KU,ALFU,SINTL,SINTR,WSU,VHU,EG,V,FRDN
C-old   IR13 = IR13 + 1                  /***********************
  350 WRITE (13,REC=IR13) M,E,KSTAR,AU,KU,ALFU,SINTL,SINTR,WSU,VHU,EG,
     1     V,FRDN
        IR13 = IR13 + 1
C---end change
  360 DISTD=DISTU
      IF (.NOT.FLDWAY) SAVEL(NOXS)=WSU
      IF (NOXS.EQ.NXSPRO) RETURN
      KD=KU
      VHD=VHU
      WSD=WSU
      QD=QU
      IF (DATA.NE.5) GO TO 20
      GO TO 10
      END
      SUBROUTINE PTABLE (KDELH,SECID)
C-old REAL*8 SECID,K*4
      CHARACTER SECID*8
      REAL K
C---end change
      LOGICAL FLDWAY,FIRST
      COMMON /INTS/ SINTL,SINTR
      COMMON /XP/ SUMP,SUMB
C-old COMMON /ID/ STRID(10),GSID(2),FWID(5),LINE
      CHARACTER*4 STRID, GSID, FWID
      COMMON /ID/ STRID(10),GSID(2),FWID(5)
      COMMON /IDI/ LINE
C---end change
      COMMON /FW/ FLDWAY
C-old COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,CD3C80
      COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,DUM380
      CHARACTER*1 CD3C80
      COMMON /XS1C/ CD3C80
C---end change
      COMMON /AV/ IR11,IR12,IR13
      COMMON /SAPARM/ K(20),A(20),B(20),R(20)
C-new
      CHARACTER*1 AAY
C---end change
      DATA AAY/'K'/
      IR13=1
      NREC=NSA/6
      IF (MOD(NSA,6).GT.0) NREC=NREC+1
      IPART=1
      LPART=1
      DELH=FLOAT(KDELH)/10.0
      IF (HSUBO.GT.GMIN) GO TO 20
      HMIN=INT(GMIN)
      I=0
   10 I=I+1
      IF (HSUBO.GT.GMIN+0.05) GO TO 20
      HSUBO=HMIN+FLOAT(I*KDELH)/10.0+0.00005
      GO TO 10
   20 NMAX=(GMAX-HSUBO)/DELH+1.99
      IF (NMAX.GT.90) NMAX=90
      LEFT=52-(LINE+7)
      IF (NMAX.LE.LEFT) GO TO 40
      IF (LEFT.GE.3) GO TO 30
      LINE=0
      LEFT=45
   30 LMAX=NMAX-LEFT
      IF (LMAX.LT.0) LMAX=0
      LPART=LPART+LMAX/45
      IF (MOD(LMAX,45).GT.0) LPART=LPART+1
   40 KHSUBO=10*HSUBO
      WS=HSUBO
      IF (LINE.GT.0) GO TO 50
      CALL VHEAD
   50 WRITE (6,200) STRID,GSID,SECID,IDIST,IPART,LPART
      LINE=LINE+7
      IF (.NOT.FLDWAY) GO TO 60
      WRITE (6,210) FWID
   60 WRITE (6,220)
      IF (NMAX.LE.0) WS=GMAX
      DO 120 N=1,NMAX
      IF (WS.GT.GMAX) WS=GMAX
      CALL XSPROP (1,NOPTS,WS,SUMA,SUMK,ALPH)
      IF (LINE.LT.52) GO TO 90
      IPART=IPART+1
      CALL VHEAD
      WRITE (6,200) STRID,GSID,SECID,IDIST,IPART,LPART
      LINE=7
      IF (.NOT.FLDWAY) GO TO 80
      WRITE (6,210) FWID
   80 WRITE (6,220)
   90 LINE=LINE+1
      QC=0.0
      IF(SUMA.LE.0.0.OR.SUMB.LE.0.0) GO TO 95
      QC=SQRT(32.17*SUMA**3/(ALPH*SUMB))
   95 IQC=QC+0.5
      IA=SUMA+0.5
      IK=SUMK+0.5
      IB=SUMB+0.5
      IP=SUMP+0.5
      ILT=SINTL+0.5
      IRT=SINTR+0.5
      WRITE (6,230) WS,IA,IK,ALPH,IB,IP,ILT,IRT,IQC
      IF (CD3C80.NE.AAY) GO TO 110
      IF (IR13+NREC-1.GT.150) GO TO 110
      DO 100 J1=1,NSA,6
      J2=MIN0(J1+5,NSA)
C-old WRITE (13'IR13) WS,(A(J),K(J),B(J),R(J),J=J1,J2)
C-old   IR13 = IR13 + 1                /**************************
      WRITE (13,REC=IR13) WS,(A(J),K(J),B(J),R(J),J=J1,J2)
        IR13 = IR13 + 1
C---end change
  100 CONTINUE
  110 IF (WS.EQ.GMAX) GO TO 130
      KWS=KHSUBO+N*KDELH
      WS=FLOAT(KWS)/10.0
  120 CONTINUE
  130 IF (CD3C80.NE.AAY) RETURN
      IPAGE=1
      LINE=5
      CALL VHEAD
      WRITE (6,260) STRID,GSID,SECID,IPAGE
      IR13 = 1
  140 DO 150 J1=1,NSA,6
      J2=MIN0(J1+5,NSA)
C-old READ (13'IR13) WS,(A(J),K(J),B(J),R(J),J=J1,J2)
C-old IR13 = IR13 + 1                               /**************************
      READ (13,REC=IR13) WS,(A(J),K(J),B(J),R(J),J=J1,J2)
      IR13 = IR13 + 1
C---end change
  150 CONTINUE
      FIRST=.TRUE.
      DO 180 I=1,NSA
      IF (A(I).LE.0.0) GO TO 180
      IF (LINE.LT.50) GO TO 160
      CALL VHEAD
      IPAGE=IPAGE+1
      WRITE (6,260) STRID,GSID,SECID,IPAGE
      LINE=5
  160 LINE=LINE+1
      IF (.NOT.FIRST) GO TO 170
      WRITE (6,270) WS,I,A(I),K(I),B(I),R(I)
      LINE=LINE+1
      FIRST=.FALSE.
      GO TO 180
  170 WRITE (6,280) I,A(I),K(I),B(I),R(I)
  180 CONTINUE
      IF (WS.LT.GMAX.AND.(IR13+NREC-1).LE.150) GO TO 140
      LINE=0
      RETURN
      ENTRY HEAD(IPAGE2,LPAGE)
      IPAGE2=IPAGE2+1
      CALL VHEAD
      WRITE (6,240) STRID,GSID,IPAGE2,LPAGE
      IF (.NOT.FLDWAY) GO TO 190
      WRITE (6,210) FWID
  190 WRITE (6,250)
      RETURN
  200 FORMAT (//20X,'CROSS-SECTION PROPERTIES FOR: ',10A4,1X,2A4/25X,'SE
     1CID=',A5,' AT DISTANCE=',I7,30X,'PART',I3,' OF',I3)
  210 FORMAT (' ',19X,'*** FLOODWAY ANALYSIS *** ',5A4)
  220 FORMAT ('0',23X,'WS',8X,'A',11X,'K',5X,'ALPHA',6X,'B',7X,'P',05X,'
     1LEW',4X,'REW',7X,'QC'/)
  230 FORMAT (20X,F7.1,I9,I12,F9.2,2I8,2I7,I10)
  240 FORMAT (//20X,79('=')/20X,'WATER-SURFACE PROFILE FOR: ',10A4,1X,2A
     14/20X,'PAGE',I3,' OF',I3)
  250 FORMAT (20X,79('=')/20X,'SECID AT DISTANCE/ LENGTH/DISCHARGE/  ARE
     1A  /CONVEYANCE/ ALPHA/  LEW  /  REW'/20X,'  WS ELEV /    HV  /
     2HF  /    HE  /     EG  /     V  /    FN  /   ACC   *ID*'/20X,79('=
     3'))
  260 FORMAT (//20X,'SUB-AREA PROPERTIES FOR: ',10A4,1X,2A4/25X,'SECID='
     1,A5,46X,'PAGE',I3//23X,'WS',6X,'SA',10X,'A',12X,'K',12X,'B',10X,'R
     2')
  270 FORMAT ('0',19X,F6.1,I7,2F13.1,F13.2,F11.2)
  280 FORMAT (31X,I2,2F13.1,F13.2,F11.2)
      END
      SUBROUTINE SETK
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
      INTEGER SKEW,PIER,ABUT,WW
      LOGICAL NOROAD,NOKP,NOKS
      COMMON /LOGIG/ NOROAD,NOKP,NOKS
      COMMON /ARAYK/ ALLKB(11,4),ALLDK(6,8),ALLSG(7,8),ALLKE(5,5),ALLKS(
     18,6)
      COMMON /KCURV/ KBARAY(11),DKARAY(6),SGARAY(7),KSARAY(8),KSUBEL(5),
     1KSUBEH(5)
C-old COMMON /BP1/ SKEW,PIER,ABUT,WW,SUBDUM,BELDUM
      COMMON /BP1/ SKEW,PIER,ABUT,WW,SUBEL,BELMX
C---end change
      ISKEW=SKEW/15+3*ABUT
      IF (ISKEW.LE.0.OR.SKEW.LT.0) NOKS=.TRUE.
      DO 20 I=1,11
      KBARAY(I)=ALLKB(I,WW)
      IF (I.GT.8) GO TO 20
      IF (NOKS) GO TO 10
      KSARAY(I)=ALLKS(I,ISKEW)
   10 IF (I.GT.7.OR.NOKP) GO TO 20
      SGARAY(I)=ALLSG(I,PIER)
      IF (I.GT.6) GO TO 20
      DKARAY(I)=ALLDK(I,PIER)
   20 CONTINUE
      RETURN
      ENTRY SETKE(IECC)
      DO 30 I=1,5
      KSUBEL(I)=ALLKE(I,IECC)
      KSUBEH(I)=ALLKE(I,IECC+1)
   30 CONTINUE
      RETURN
      END
      FUNCTION TERPL8 (YO,I1,I2,Y,Z)
      DIMENSION Y(1), Z(1)
      IF (YO.GT.Y(I1)) GO TO 10
      I=I1
      GO TO 30
   10 DO 20 I=I1,I2
      IF (YO.GE.Y(I).AND.YO.LT.Y(I+1)) GO TO 30
   20 CONTINUE
      I=I2
   30 TERPL8=Z(I)+(YO-Y(I))*(Z(I+1)-Z(I))/(Y(I+1)-Y(I))
      RETURN
      ENTRY PROP(YO,Y,Z,II)
      PROP=Z(II)+(YO-Y(II))*(Z(II+1)-Z(II))/(Y(II+1)-Y(II))
      RETURN
      ENTRY THEMIN(I1,I2,Z)
      THEMIN=Z(1)
      DO 40 I=I1,I2
      IF (Z(I).LT.THEMIN) THEMIN=Z(I)
   40 CONTINUE
      RETURN
      ENTRY THEMAX(NMAX,Z)
      THEMAX=Z(1)
      DO 50 I=2,NMAX
      IF (Z(I).GT.THEMAX) THEMAX=Z(I)
   50 CONTINUE
      RETURN
      ENTRY KCHECK(XI,ILT,IRT,ORIGK,ENCK,SUMK)
      KCHECK=2
      CALL XSPROP (ILT,IRT,XI,SUMA,SUMK,ALFA)
      ERROR=(SUMK-ENCK)/ORIGK
      IF (ERROR) 60,90,70
   60 KCHECK=1
      GO TO 80
   70 KCHECK=3
   80 IF (ABS(ERROR).LE.0.0005) KCHECK=2
   90 RETURN
      END
      SUBROUTINE UTILIT
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
      LOGICAL NOROAD,NOKP,NOKS
      COMMON /LOGIG/ NOROAD,NOKP,NOKS
      COMMON /PROF/ WSD,WSU,VHD,VHU,KD,KU,HF,HE,AU,ALFU,DIST,QBO,A2N,H1N
     1,TOL,QT,QAVG,TEDS
      COMMON /QR/ QRL,QRR
C-old COMMON /BP2/ M,IECC,E,AJ,IFLOW
      COMMON /BP2/ M,IECC,E,AJ,IFLOW,BRWID,A2FULL,AJF
C---end change
      COMMON /BP4/ RGLMN,RGRMN,QTOL,RDIST
      COMMON /BP5/ KSTAR
C-old COMMON /BP6/ IQL,IQR,NSEG
      COMMON /BP6/ ISEGL,ISEGR,NSEG
C---end change
      COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,DUM380
      ENTRY FOFX(X,FX)
      CALL XSPROP (1,NOPTS,X,AU,KU,ALFU)
      VHU=ALFU*(QT/AU)**2/64.3
      HF=DIST*QAVG**2/(KD*KU)
      KJ=0.5
      IF (VHU-VHD.LE.0.0) KJ=0.0
      HE=KJ*(VHU-VHD)
      FX=X+VHU-HF-HE-WSD-VHD
      RETURN
      ENTRY BWCOEF
      KSKEW=0
      KECC=0
      KPIER=0
      CALL DETME
      KBASE=KSUBB(M)
      IF (NOKS) GO TO 10
      KSKEW=KSUBS(M)
   10 IF (NOKP) GO TO 20
      KPIER=KSUBP(AJ,M)
   20 IF (IECC.LE.0) GO TO 30
      KECC=KSUBE(M,E,IECC)
   30 KSTAR=KBASE+KSKEW+KPIER+KECC
      IF (KSTAR.LT.0.0064) KSTAR=0.0064
      RETURN
      ENTRY ROADQ
      QRL=0
      QRR=0
      VHU=ALFU*(QT/AU)**2/64.3
      IF (NOROAD) RETURN
      FH=RDIST*(QT/KU)**2
      EGR=WSU+VHU-FH
C-old IF (WSU.GT.RGLMN) QRL=WEIRQ(RGLMN,1,IQL,EGR)
C-old IF (WSU.GT.RGRMN) QRR=WEIRQ(RGRMN,IQR,NSEG,EGR)
      IF (WSU.GT.RGLMN) QRL=WEIRQ(RGLMN,1,ISEGL,EGR)
      IF (WSU.GT.RGRMN) QRR=WEIRQ(RGRMN,ISEGR,NSEG,EGR)
C---end change
      RETURN
      END
      FUNCTION WEIRC (TOVRH,J)
      COMMON /WCOEF/ HLHTH(36),COEF(36),LIMIT(3,2,2)
      TH=TOVRH
      WEIRC=TERPL8(TOVRH,LIMIT(3,1,J),LIMIT(3,2,J),HLHTH,COEF)
      RETURN
      ENTRY FIG22(HOVRL,J)
      FIG22=TERPL8(HOVRL,LIMIT(1,1,J),LIMIT(1,2,J),HLHTH,COEF)
      RETURN
      ENTRY FIG23(HEAD,J)
      FIG23=TERPL8(HEAD,LIMIT(2,1,J),LIMIT(2,2,J),HLHTH,COEF)
      RETURN
      END
      FUNCTION WEIRQ (RDMIN,I1,I2,EGR)
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
      COMMON /RDATA/ RDEL(50),RDSTA(50),ISEG(50),IT(10),RDWID,NGRD
      COMMON /PROF/ WSD,WSU,VHD,VHU,KD,KU,HF,HE,AU,ALFU,DIST,QBO,A2N,H1N
     1,TOL,QT,QAVG,TEDS
      WSRD=RDMIN+5.0*(EGR-RDMIN)/6.0
      IF (WSRD.GT.WSU) WSRD=WSU
      WEIRQ=0
      I=1
   10 IF (ISEG(I).LT.I1) GO TO 110
      L=ISEG(I)
      ITYPE=IT(L)
      IF (WSRD.LE.RDEL(I).AND.WSRD.LE.RDEL(I+1)) GO TO 110
      IF (WSRD.LT.RDEL(I).OR.WSRD.LT.RDEL(I+1)) GO TO 20
      B=RDSTA(I+1)-RDSTA(I)
      AVGEL=(RDEL(I)+RDEL(I+1))/2.0
      GO TO 40
   20 IF (WSRD.GE.RDEL(I).OR.WSRD.LE.RDEL(I+1)) GO TO 30
      B=RDSTA(I+1)-PROP(WSRD,RDEL,RDSTA,I)
      AVGEL=(WSRD+RDEL(I+1))/2.0
      GO TO 40
   30 B=PROP(WSRD,RDEL,RDSTA,I)-RDSTA(I)
      AVGEL=(RDEL(I)+WSRD)/2.0
   40 H=EGR-AVGEL
      IF(H.LE.0.0) GO TO 110
      HS=H-VHU
      IF(HS.LT.0.0) HS=0.0
      T=WSD-AVGEL
      IF (ITYPE.EQ.1.AND.T/H.GT.0.8) GO TO 50
      IF (ITYPE.EQ.2.AND.T/H.GT.0.7) GO TO 50
      KSUBT=1.00
      GO TO 60
   50 KSUBT=WEIRC(T/H,ITYPE)
   60 IF (H/RDWID.GT.0.15) GO TO 80
      IF(HS.LT.4.0) GO TO 70
      CF=3.05
      GO TO 100
   70 CF=FIG23(H,ITYPE)
      GO TO 100
   80 IF(HS/RDWID.LT.0.32) GO TO 90
      CF=3.09
      GO TO 100
   90 CF=FIG22(HS/RDWID,ITYPE)
  100 C=CF*KSUBT
      Q=C*B*H**1.5
      WEIRQ=WEIRQ+Q
  110 I=I+1
      IF (ISEG(I).LE.I2.AND.I.LT.NGRD) GO TO 10
      RETURN
      END
      SUBROUTINE XSPROP (I1,I2,XI,SUMA,SUMK,ALPH)
      IMPLICIT REAL(A-H,K,M,O-Z),INTEGER(I,J,L,N)
      REAL N,NUM,N1,N3
      INTEGER H,DATA,SA
      LOGICAL XTENDL,XTENDR
      COMMON /XTEND/ XTENDL,XTENDR
      COMMON /XS1/ NSA,NOPTS,GMIN,GMAX,HSUBO,IDIST,DUM380
      COMMON /XP/ SUMP,SUMB
      COMMON /INTS/ SINTL,SINTR
      COMMON /XSDATA/ S(200),SA(200),G(200),BL(20),AB(20),N1(20),N3(20)
      COMMON /FLAG/ DATA
      COMMON /SAPARM/ K(20),A(20),B(20),R(20)
      DIMENSION WP(20), DM(20)
      DO 10 I=1,NSA
      A(I)=0.0
      B(I)=0.0
      DM(I)=0
      R(I)=0.0
   10 WP(I)=0.0
      XTENDL=.FALSE.
      XTENDR=.FALSE.
      SUMA=0.0
      SUMB=0.0
      SUMK=0.0
      SUMP=0.0
      NUM=0.0
      TOP=0.0
      LAPL=0
      LAPR=0
      I=I1
      SINT=10000000.
      SINTR=-100000.
      SINTL=1000000.
   20 H=SA(I)
      IF (H.LT.0) GO TO 100
      IF (XI.LE.G(I).AND.XI.LE.G(I+1)) GO TO 90
      IF (XI.LT.G(I).OR.XI.LT.G(I+1)) GO TO 30
      BASE=S(I+1)-S(I)
      SINT=S(I+1)
      IF (SINTL.GT.SINTR) SINT=S(I)
      IF (I.EQ.I1.AND.XI.GE.G(I)) SINTL=S(I)
      ALT=G(I+1)-G(I)
      DELA=BASE*(XI-0.5*(G(I)+G(I+1)))
      IF (I.EQ.I1.AND.(DATA.NE.2.AND.DATA.NE.9)) LAPL=1
      IF (I+1.EQ.I2.AND.(DATA.NE.2.AND.DATA.NE.9)) LAPR=1
      GO TO 60
   30 IF (XI.GE.G(I).OR.XI.LE.G(I+1)) GO TO 40
      ALT=XI-G(I+1)
      BASE=ALT*(S(I+1)-S(I))/(G(I)-G(I+1))
      SINT=S(I+1)-BASE
      GO TO 50
   40 ALT=XI-G(I)
      BASE=ALT*(S(I+1)-S(I))/(G(I+1)-G(I))
      SINT=S(I)+BASE
   50 DELA=0.5*ALT*BASE
   60 DELWP=SQRT(BASE**2+ALT**2)
      B(H)=B(H)+BASE
      A(H)=A(H)+DELA
      IF (LAPL.NE.1) GO TO 70
      LAPL=0
      IF (XI.LE.G(I1)) GO TO 70
      DELWP=DELWP+(XI-G(I1))
      XTENDL=.TRUE.
   70 IF (LAPR.NE.1) GO TO 80
      LAPR=0
      IF (XI.LE.G(I2)) GO TO 80
      DELWP=DELWP+(XI-G(I2))
      XTENDR=.TRUE.
   80 WP(H)=WP(H)+DELWP
      GO TO 100
   90 IF (XI.NE.G(I).OR.XI.NE.G(I+1)) GO TO 100
      TOP=S(I+1)-S(I)
      IF (TOP.GE.0) GO TO 100
      WP(H)=WP(H)-TOP
      B(H)=B(H)+TOP
  100 I=I+1
      IF (SINT.EQ.10000000.) GO TO 110
      IF (SINT.LT.SINTL) SINTL=SINT
      IF (SINT.GT.SINTR) SINTR=SINT
  110 IF (I.LT.I2) GO TO 20
      DO 190 H=1,NSA
      IF (B(H).GT.0.01) GO TO 120
      DM(H)=AB(H)
      GO TO 130
  120 DM(H)=A(H)/B(H)
  130 IF (DM(H).GT.BL(H)) GO TO 140
      N=N1(H)
      GO TO 170
  140 IF (DM(H).LT.AB(H)) GO TO 150
      N=N3(H)
      GO TO 170
  150 IF (AB(H).NE.BL(H)) GO TO 160
      N=N3(H)
      GO TO 170
  160 N=N1(H)+(N3(H)-N1(H))*(DM(H)-BL(H))/(AB(H)-BL(H))
  170 K(H)=0.0
      IF (WP(H).EQ.0.0) GO TO 180
      R(H)=A(H)/WP(H)
      K(H)=(1.49/N)*A(H)*R(H)**(2.0/3.0)
  180 ALT=0.0
      IF (A(H).NE.0.0) ALT=K(H)**3/A(H)**2
      SUMK=SUMK+K(H)
      NUM=NUM+ALT
      SUMA=SUMA+A(H)
      SUMB=SUMB+B(H)
      IF (A(H).NE.0.0) SUMP=SUMP+WP(H)
  190 CONTINUE
      ALPH=1.0
      IF (SUMK.NE.0.0) ALPH=NUM*SUMA*SUMA/SUMK**3
      RETURN
      ENTRY SAKAB(KSAMX,ASAMX,BSAMX)
      KSAMX=K(1)
      IMAX=1
      IF (NSA.EQ.1) GO TO 210
      DO 200 I=2,NSA
      IF (K(I).LT.KSAMX) GO TO 200
      KSAMX=K(I)
      IMAX=I
  200 CONTINUE
  210 ASAMX=A(IMAX)
      BSAMX=B(IMAX)
      RETURN
      ENTRY KSUM(I1,I2,SUMK)
      SUMK=0.0
      DO 220 I=I1,I2
  220 SUMK=SUMK+K(I)
      RETURN
      END
C==================================================  DATME        ======
      SUBROUTINE  DATME(IALF)
C
C-old
C  CURRENT DATE AND TIME RETURNED TO INTEGER*4 ARRAY
C  TO PRINT AS 5A3.  FORMAT IS .....MM/DD/YY HH:MM .....
C-new
C  CURRENT DATE AND TIME RETURNED TO CHARACTER*14 VARIABLE
C  TO PRINT AS A14.  FORMAT IS .....MM/DD/YY HH:MM .....
C---end change
C
C      *****  PRIME  FORTRAN  77  *****
C
C   SUBPGMS USED --  TIMDAT (PRIME SYSTEM ROUTINE)
C
C-old INTEGER*2  IARRAY(28), NUM /28/
C-old INTEGER*4  IALF(5), IREG(5),  HOUR, MINS
C-old CHARACTER*20 WORK
C-old EQUIVALENCE  (IARRAY(5), WORK, IREG(1))
      INTEGER*2  IARRAY(5), NUM
      INTEGER*4  HOUR, MINS
      CHARACTER*14 IALF
      DATA NUM/5/
C---end change
C
      CALL  TIMDAT(IARRAY, NUM)
C
      HOUR = IARRAY(4)/60
      MINS = IARRAY(4) - 60*HOUR
C-old WRITE(WORK,10) (IARRAY(I),I=1,3), HOUR, MINS
C-old 10 FORMAT( A2,'/ ', A2,'/ ', A2,2X,    I2.2,': ', I2.2,2X)
C-old DO 20 I=1, 5
C-old   20 IALF(I) = IREG(I)
      WRITE(IALF,10) (IARRAY(I),I=1,3), HOUR, MINS
   10 FORMAT(2(I2.2,'/'),I2.2,I3.2,':',I2.2)
C---end change
      RETURN
      END
