      SUBROUTINE FILE_BASE
     I                    ( INFILE,
     O                      LENNAM, LENBAS )
C     + + + PURPOSE + + +
C     Determine the number of characters of a file name, minus any
C     up to three letter suffix (the base name).
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) INFILE
      INTEGER LENNAM, LENBAS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INFILE - File name to determine number of characters in base name.
C     LENNAM - Number of characters in file name.
C     LENBAS - Number of characters in base name.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER i, idot, j, numch
C
C     + + + INTRINSICS + + +
      INTEGER LEN
      INTRINSIC LEN
C
C     + + + END SPECIFICATIONS + + +
C
      numch = LEN(INFILE)
      DO 20 i = numch, 1, -1
        IF (INFILE(i:i).NE.' ') THEN
          LENNAM = i
C---determine location of last "." in name, if present
          DO 10 j = LENNAM, 1, -1
            IF (INFILE(j:j).EQ.'.') THEN
              idot = j - 1
              GOTO 30
            ENDIF
   10     CONTINUE
          idot = 0
          GOTO 30
        ENDIF
   20 CONTINUE
      LENNAM = numch
C---determine if an up to 3 letter suffix was found
   30 LENBAS = LENNAM
      IF (idot.GT.0 .AND. LENNAM-idot.LT.5) LENBAS = idot
C---be sure base name allows addition of a 4 character suffix 
C---such as ".prt".
      IF (LENBAS.GT.numch-4) LENBAS = numch - 4
      RETURN
      END
